#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define INF 66666666

int N;
int Px[403], Py[403];

int X[403], Y[403];
int Xn, Yn;

int A[403][403];

int remove_dup(int *A)
{
    int i, j;
    for (i = j = 0; i < N;)
        for (A[j++] = A[i++]; i < N && A[i] == A[i-1]; i++);
    return j;
}

int cmp(const void *a, const void *b)
{
    return *((int *) a) - *((int *) b);
}

int search(int *A, int s, int x)
{
    int l, r, m;
    for (l = 0, r = s-1; l < r; )
        if (A[m = (l+r+1)/2] <= x)
           l = m;
        else
           r = m-1;
    return l;
}

void process()
{
    int i, j;
    memcpy(X, Px, N * sizeof(int));
    memcpy(Y, Py, N * sizeof(int));
    qsort(X, N, sizeof(int), cmp);
    qsort(Y, N, sizeof(int), cmp);
    Xn = remove_dup(X);
    Yn = remove_dup(Y);
    for (i = 0; i < Xn; i++)
     for (j = 0; j < Yn; j++)
         A[i][j] = INF;
         
    for (i = 0; i < N; i++)
        A[search(X, Xn, Px[i])][search(Y, Yn, Py[i])] = 0;
        
    for (i = 0; i < Xn; i++)
     for (j = 0; j < Yn; j++)
     {
         if (i > 0 &&
             A[i][j] > A[i-1][j] + X[i] - X[i-1])
             A[i][j] = A[i-1][j] + X[i] - X[i-1];
         if (j > 0 &&
             A[i][j] > A[i][j-1] + Y[j] - Y[j-1])
             A[i][j] = A[i][j-1] + Y[j] - Y[j-1];
     }
    for (i = Xn-1; i >= 0; i--)
     for (j = Yn-1; j >= 0; j--)
     {
         if (i < Xn-1 &&
             A[i][j] > A[i+1][j] + X[i+1] - X[i])
             A[i][j] = A[i+1][j] + X[i+1] - X[i];
         if (j < Yn-1 &&
             A[i][j] > A[i][j+1] + Y[j+1] - Y[j])
             A[i][j] = A[i][j+1] + Y[j+1] - Y[j];
     }
}

int query(int xx, int yy)
{
    int i, j, x, y, r = INF, t;
    x = search(X, Xn, xx);
    y = search(Y, Yn, yy);
    for (i = 0; i < 2 && x+i < Xn; i++)
     for (j = 0; j < 2 && y+j < Yn; j++)
         if ((t = A[x+i][y+j] + abs(X[x+i]-xx) + abs(Y[y+j]-yy)) < r)
            r = t;
    return r;
}

void read_and_solve()
{
    FILE *fi = fopen("ajutor.in", "rt");
    FILE *fo = fopen("ajutor.out", "wt");
    int i, m, x, y;
    fscanf(fi, "%d %d", &N, &m);
    for (i = 0; i < N; i++)
        fscanf(fi, "%d %d", Px+i, Py+i);
    process();
    for (; m > 0; m--)
    {
        fscanf(fi, "%d %d", &x, &y);
        fprintf(fo, "%d\n", query(x, y));
    }
    fclose(fo);
    fclose(fi);
}

int main()
{
    read_and_solve();
    return 0;
}
