#include <string.h>
#include <stdio.h>
#include <stdlib.h>


#define IN_NAME "ghizi.in"
#define OUT_NAME "ghizi.out"

#define N_MAX 101

#define T 100
#define S 0


typedef struct node {
    int order;
    struct node *next;
} node_t;


int C[N_MAX][N_MAX];
int F[N_MAX][N_MAX];
int sel[N_MAX], pi[N_MAX];
int N, K;
node_t *A[N_MAX][N_MAX];
int guide[5001];


void read_data(void)
{
    FILE *in_file = fopen(IN_NAME, "rt");
    int i, j, k;
    node_t *p;

    fscanf(in_file, "%d %d\n", &N, &K);
    for (k = 0; k < N; k++) {
	fscanf(in_file, "%d %d\n", &i, &j);
	C[i][j]++;
	p = (node_t *) malloc(sizeof( node_t));
	p->order = k + 1;
	p->next = A[i][j];
	A[i][j] = p;
    }
    fclose(in_file);
}


void write_solution(int count)
{
    FILE *out_file = fopen(OUT_NAME, "wt");
    int i;

    fprintf(out_file, "%d\n", count);
    for (i = 1; i <= N; i++)
	if (guide[i])
	    fprintf(out_file, "%d ", i);
    fprintf(out_file, "\n");
    fclose(out_file);

    exit(EXIT_SUCCESS);
}


void solve(void)
{
#define Q_LEN 101
    int Q[Q_LEN], Qh, Qt;
    int sel[N_MAX], pi[N_MAX];
    int i, j, k, flag, flow;

    flow = 0;
    while (1) {
	memset(sel, 0, sizeof(sel));
	flag = 0;
	Qh = Qt = 0;
	Q[Qt++] = S;
	sel[0] = 1;
	while (Qh != Qt && !flag) {
	    i = Q[Qh++];
	    for (j = 1; j <= T && !flag; j++)
		if (!sel[j] && (C[i][j] - F[i][j] > 0)) {
		    pi[j] = i;
		    sel[j] = 1;
		    Q[Qt++] = j;
		    if (j == T) {
			flow++;
			for (k = T; k != 0; k = pi[k]) {
			    F[pi[k]][k]++;
			    F[k][pi[k]]--;
			}
			flag = 1;
		    }
		}	
	}
	if (flow == K) {
	    int count = 0;
	    node_t *p;

	    for (i = 0; i <= T; i++)
		for (j = i; j <= T; j++)
		    if (F[i][j]) { 
			count += F[i][j];
			for (p = A[i][j], k = 0; k < F[i][j]; p = p->next, k++)
			    guide[p->order] = 1;
		    }
	    write_solution(count);
	}
    }
}


int main(void)
{
    read_data();
    solve();

    return EXIT_SUCCESS;
}
