#include <stdio.h>
#include <string.h>

#define maxc 300
#define base 10
#define displ "%01d"

typedef int num_t[maxc];

void add(num_t A, num_t B)
{
    int i, t = 0;
    for (i = 1; i <= A[0] || i <= B[0] || t; i++, t /= base)
        A[i] = (t += A[i]+B[i]) % base;
    A[0] = i-1;
}

void mul(num_t A, int x)
{
    int i, t = 0;
    for (i = 1; i <= A[0] || t; i++, t /= base)
        A[i] = (t += A[i]*x) % base;
    A[0] = i-1;
}

num_t A[105];

int N, K, P;

void solve()
{
    int i, j;

    N -= K;
    A[K][0] = A[K][1] = 1;
    for (i = 1; i <= N; i++)
    {
        for (j = P; j >= 1 && j >= K; j--)
        {
            mul(A[j], j);
            add(A[j], A[j-1]);
        }
        memset(A[0], 0, sizeof(num_t));
    }
}

void print()
{
    FILE *fo = fopen("ex.out", "wt");
    int i;
    fprintf(fo, "%d", A[P][A[P][0]]);
    for (i = A[P][0]-1; i > 0; i--)
        fprintf(fo, displ, A[P][i]);
    fprintf(fo, "\n");
    fclose(fo);
}

void read_data()
{
    FILE *fi = fopen("ex.in", "rt");
    fscanf(fi, "%d %d %d", &N, &K, &P);
    fclose(fi);
}

int main()
{
    read_data();
    solve();
    print();
    return 0;
}

