program telegraf;
const
  sin='telegraf.in';
  sout='telegraf.out';
  n=36;
type
  ta=array[0..n]of longint;
var
  fin,fout:text;
  freq:ta;
  sol:longint;
  NN:shortint;
  soltimes:ta;

procedure read_data;
var
  i:longint;
begin
  assign(fin,sin);
  reset(fin);
  for i:=1 to n do
    read(fin,freq[i]);
  close(fin);
end;

procedure swap_l(var a,b:longint);
var
  c:longint;
begin
  c:=a;
  a:=b;
  b:=c;
end;

procedure sort_data;
var
  maxpoz,i,j:shortint;
begin
  for i:=1 to n-1 do
    begin
      maxpoz:=i;
      for j:=i+1 to n do
        if freq[j]>freq[maxpoz] then
          maxpoz:=j;
      swap_l(freq[maxpoz],freq[i]);
    end;
  nn:=n;
  while freq[nn]=0 do
    dec(nn);
end;

procedure expand(n:shortint);

  procedure Expand_This(poz:longint;var a:ta);

    procedure bubble_it(poz,n:longint);
    begin
      while (poz<>n) and (a[poz]>a[poz+1]) do
        begin
          swap_l(a[poz],a[poz+1]);
          inc(poz);
        end;

    end;

  var
    i,aa:longint;
  begin
    aa:=a[poz];
    a[poz]:=a[poz]+1;
    bubble_it(poz,n-1);
    for i:=n downto 2 do
      a[i]:=a[i-1];
    a[1]:=aa+2;
    bubble_it(1,n);
  end;

  function GetCost(a:ta):longint;
  var
    i,ret:longint;
  begin
    ret:=0;
    for i:=1 to n do
      ret:=ret+a[i]*freq[i];
    GetCost:=ret;
  end;

var
  poz:shortint;
  besttimes:ta;
  bestcost:longint;
  bestPoz:longint;
  pozCost:longint;
  PozTimes:ta;
begin
  besttimes:=soltimes;
  Expand_This(1,besttimes);
  bestcost:=GetCost(besttimes);
  bestPoz:=1;
  for poz:=2 to n-1 do
    if soltimes[poz]<>soltimes[poz-1] then
      begin
        pozTimes:=soltimes;
        Expand_This(poz,pozTimes);
        pozCost:=GetCost(pozTimes);
        if pozCost<bestCost then
          begin
            bestCost:=pozCost;
            bestTimes:=PozTimes;
            bestPoz:=poz;
          end;
      end;
  SolTimes:=BestTimes;
  sol:=bestCost;
end;

procedure go_solve;
var
  i:longint;
begin
  soltimes[0]:=0;
  soltimes[1]:=1;
  soltimes[2]:=2;
  for i:=3 to nn do
    expand(i);
end;

procedure comp_data;
begin
  if nn=2 then
    sol:=freq[1]+freq[2]*2
  else
    go_solve;
end;

procedure write_sol;
begin
  assign(fout,sout);
  rewrite(fout);
  writeln(fout,sol);
  close(fout);
end;

begin
  read_data;
  sort_data;
  comp_data;
  write_sol;
  halt(0);
end.