#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N 10010
#define MY_PI 3.14159265358979

struct brat {
   int Id;
   int l;
   double angle;
};
typedef struct brat brat;

int n, X, Y;
brat b[N];
int Max[N], Min[N];
double d, angle, Cos[360], Sin[360], sum;

#define min(a,b) ( (a) < (b) ? (a) : (b) )
#define dist(a,b,c,d) ( (c-a)*(c-a)+(d-b)*(d-b) )
#define SIN(x) ( sin( x * MY_PI / 180 ) )
#define COS(x) ( cos( x * MY_PI / 180 ) )

void read ()
{
   int i;
   
   FILE *f = fopen( "robot.in", "rt" );
   fscanf( f, "%d", &n );
   for ( i = 1; i <= n; i++ )
   {
      b[i].Id = i;
      fscanf( f, "%d", &b[i].l );
   }
   fscanf( f, "%d%d", &X, &Y );
   d = sqrt( X*X + Y*Y );
   fclose( f );
}

int cmp (const void *a, const void *b)
{
   return ((brat *)b)->l - ((brat *)a)->l;
}

int cmp2 (const void *a, const void *b)
{
   return ((brat *)a)->Id - ((brat *)b)->Id;
}

void init ()
{
   int i;
   double alpha;

//   qsort( b + 1, n, sizeof( brat ), cmp );
   for ( i = n; i; i-- )
   {
      Max[i] = Max[i+1] + b[i].l;
      Min[i] = abs( Min[i+1] - b[i].l );
   }

   for ( i = 0; i < 360; i++ )
   {
      alpha = i * MY_PI / 180;
      Cos[i] = cos( alpha );
      Sin[i] = sin( alpha );
   }
}

void print (int code)
{
   int i;
   FILE *fout;
   fout = fopen( "robot.out", "wt" );
   if ( code )
   {
      for ( i = 1; i <= n; i++ )
         fprintf( fout, "%.10lf\n", b[i].angle );
   }
   else
      fprintf( fout, "0\n" );
   fclose( fout );
}

double unghi (double Y, double X)
{
   double angle;
   
   angle = atan2( Y, X ) * 180.0 / MY_PI;
   return angle + 360 * (angle < -1e-10);
}


void solve ()
{
   double x, y, newx, newy, L, D, res, min;
   double palpha, qalpha, falpha;
   int alpha;
   int i;
   
   if ( d > Max[1] || d < Min[1] )
   {
      print( 0 );
      return;
   }

   x = 0; y = 0;
   for ( i = 1; i <= n - 2; i++ )
   {
      for ( alpha = 0; alpha < 360; alpha++ )
      {
         newx = x + b[i].l * Cos[alpha]; newy = y + b[i].l * Sin[alpha];
         if ( (res = sqrt( dist( newx, newy, X, Y ) )) >= Min[i + 1] &&
              res <= Max[i + 1] )
            break;
      }
      b[i].angle = alpha;
      sum += alpha;
      x = newx; y = newy;
   }

   L = b[n-1].l;
   D = b[n].l;

   min = 2000000000000;
   for ( alpha = 0; alpha < 360; alpha++ )
   {
      newx = x + L * Cos[alpha]; newy = y + L * Sin[alpha];
      if ( ( res = fabs( sqrt( dist( newx, newy, X, Y ) ) - D ) ) < min )
         palpha = alpha, min = res;
   }

   for ( falpha = palpha; falpha <= palpha + 1; falpha += 1e-5 )
   {
      newx = x + L * COS( falpha ); newy = y + L * SIN( falpha );
      if ( ( res = fabs( sqrt( dist( newx, newy, X, Y ) ) - D ) ) < min )
         qalpha = falpha, min = res;
   }

   for ( falpha = palpha; falpha >= palpha - 1; falpha -= 1e-5 )
   {
      newx = x + L * COS( falpha ); newy = y + L * SIN( falpha );
      if ( ( res = fabs( sqrt( dist( newx, newy, X, Y ) ) - D ) ) < min )
         qalpha = falpha, min = res;
   }

   newx = x + L * COS( qalpha ); newy = y + L * SIN( qalpha );
   b[n-1].angle = qalpha - sum + 360 * (sum > qalpha + 1e-10);
   sum += b[n-1].angle;
   b[n].angle = unghi( Y - newy, X - newx );
   b[n].angle = b[n].angle - sum + 360 * (sum > b[n].angle + 1e-10);

   print( 1 );
}


int main ()
{
   read();
   init();
   solve();
   return 0;
}
