#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#ifdef __BORLANDC__
//#pragma option -3 -G -Z -O2
long far *timer = (long far *)0x46c;
long timeout;
#define t_init() { timeout = *timer + 5; }
#define t_left() (*timer < timeout)
#else
#include <signal.h>
#include <sys/time.h>
volatile int timeout = 1;
void shnd() {
	timeout = 0;
}
void t_init() {
	struct itimerval tv;
	
	signal(SIGALRM, shnd);
	tv.it_value.tv_sec = 0;
	tv.it_value.tv_usec = 95000;
	tv.it_interval.tv_sec = 0;
	tv.it_interval.tv_usec = 0;
	setitimer(ITIMER_REAL, &tv, 0);
}
#define t_left()		(timeout)
#endif

long x_freq[64];
long cmin[64][64];
long sum[64][64];
int croot[64][64];
int n;

long do_tree() {
	long mc, cc;
	int mr;
	int x, y, i;

	// precompute sums
	for(x = 0; x < n; x++) {
		sum[x][x] = x_freq[x];
		for(y = x + 1; y < n; y++)
			sum[x][y] = sum[x][y - 1] + x_freq[y];
	}

	// initialize dynamics
	for(x = 0; x < n; x++) {
		cmin[x][x] = 0;
		croot[x][x] = x;
	}

	// do dynamics
	for(i = 1; i <= n; i++) {
		for(x = 0; x < n - i; x++) {
			mc = 0x7fffffff;
//			for(y = croot[x][x + i - 1]; y < croot[x + 1][x + i]; y++)  {
			for(y = x; y < x + i; y++) {
				cc = sum[x][y] + (sum[y + 1][x + i] << 1) + cmin[x][y] + cmin[y + 1][x + i];
				if(mc > cc) { mc = cc; mr = y; }
			}
			cmin[x][x + i] = mc;
			croot[x][x + i] = mr;
		}
	}
	return cmin[0][n - 1];
}

long freq[64];
int lcmp(void const *a, void const *b) {
	if(*(long *)b - *(long *)a)
		return (*(long *)b > *(long *)a) ? 1 : -1;
	return 0;
}
int main() {
	long rmax;
	long mv, cv;
	long t;
	FILE *fp;
	int x, y, mx, my;

	t_init();
	srand(time(0));

	// load
	fp = fopen("telegraf.in", "rt");
	for(x = 0; x < 36; x++) fscanf(fp, "%ld", &freq[x]);
	fclose(fp);
	qsort(freq, 36, sizeof(freq[0]), lcmp);
	for(n = 0; freq[n]; n++);

	memcpy(x_freq, freq, sizeof(freq));
	rmax = cv = do_tree();
	while(t_left()) {
		// sort given perm until tree form is achieved
		while(t_left()) {
			mv = cv; mx = -1;
			for(x = 0; x < n; x++) {
				for(y = x + 1; y < n; y++) {
					t = x_freq[x]; x_freq[x] = x_freq[y]; x_freq[y] = t;
					cv = do_tree(); if(rmax > cv) rmax = cv;
					if(cv < mv) { mv = cv; mx = x; my = y; }
					t = x_freq[x]; x_freq[x] = x_freq[y]; x_freq[y] = t;
				}
			}
			if(mx == -1) break;
			t = x_freq[mx]; x_freq[mx] = x_freq[my]; x_freq[my] = t;
			cv = mv;
		}

		// re-randomize, to avoid local minimums
		for(mx = 0; mx < n; mx++) {
			x = rand() % n; y = rand() % n;
			t = x_freq[x]; x_freq[x] = x_freq[y]; x_freq[y] = t;
		}
	}

	// score
	fp = fopen("telegraf.out", "wt");
	fprintf(fp, "%ld\n", rmax);
	fclose(fp);

	return 0;
}

