#include <stdio.h>
#include <stdlib.h>


#define IN_NAME "ex.in"
#define OUT_NAME "ex.out"


#define N_MAX	100
long long A[N_MAX + 1][N_MAX + 1];
long long C[N_MAX + 1][N_MAX + 1];
int N, K, P;
long long Total;
int stack[N_MAX + 1], fixed[N_MAX + 1];


void read_data(void)
{
    FILE *in_file = fopen(IN_NAME, "rt");

    fscanf(in_file, "%d %d %d\n", &N, &K, &P);
    fclose(in_file);
}


void precalculate(void)
{
    int i, j;

    C[0][0] = 1;
    C[1][0] = 1;
    C[1][1] = 1;
    for (i = 2; i <= N_MAX; i++)
	for (j = 0; j <= i; j++)
	    C[i][j] = C[i - 1][j] + (j ? C[i - 1][j - 1] : 0);
}


long long back(int lv, int rest)
{
    int i;
    long long __sum = 0;

    if (lv == P - K) {
	if (rest != 0)
	    return 0;
	else
	    return 1;
    }
    else {
	for (i = lv ? stack[lv - 1] : 1; i <= rest; i++) {
	    __sum += (long long) C[rest][i] * back(lv + 1, rest - i);
	}
	return __sum;
    }
}


void solve(void)
{
    int i, j, k;

    precalculate();
    for (j = 0; j <= N - K; j++) A[0][j] = C[N - K][j];
    for (i = 1; i < K; i++)
	for (j = 0; j <= N - K; j++)
	    for (A[i][j] = 0, k = 0; k <= j; k++)
		A[i][j] += C[N - K - (j - k)][k] * A[i - 1][j - k];
    for (k = 0; k <= N - K; k++)
	Total += A[K - 1][k] * back(0, N - K - k);
    {
	FILE *out_file = fopen(OUT_NAME, "wt");

	fprintf(out_file, "%lld\n", Total);
	fclose(out_file);
    }
}


int main(void)
{
    read_data();
    solve();

    return EXIT_SUCCESS;
}
