#include <stdio.h>
#include <stdlib.h>


#define IN_NAME	"telegraf.in"
#define OUT_NAME "telegraf.out"

#define INF	(1 << 30)
#define N_MAX	36


int coef[N_MAX], paired[N_MAX], cost[N_MAX];
int Total = 0;


void read_data(void)
{
    int i;
    FILE *in_file = fopen(IN_NAME, "rt");

    for (i = 0; i < N_MAX; i++)
	fscanf(in_file, "%d ", coef + i);
    fclose(in_file);
}


int compare_ints(const void *a, const void *b)
{
    return *((const int *) b) - *((const int *) a);
}


void solve(void)
{
    int i, n_str;
    int optimal, type, where;

    qsort(coef, N_MAX, sizeof(int), compare_ints);
    cost[0] = 1;
    cost[1] = 2;
    for (n_str = 2; n_str < N_MAX && coef[n_str]; n_str++) {
	optimal = INF;
	for (i = 0; i < n_str; i++) {
	    if (optimal > (cost[i]+1) * coef[i] + (cost[i]+2) * coef[n_str]) {
		optimal = (cost[i]+1) * coef[i] + (cost[i]+2) * coef[n_str];
		where = i;
		type = 0;
	    }
	    if (optimal > (cost[i]+2) * coef[i] + (cost[i]+1) * coef[n_str]) {
		optimal = (cost[i]+2) * coef[i] + (cost[i]+1) * coef[n_str];
		where = i;
		type = 1;
	    }
	}
	if (type == 0) {
	    cost[n_str] = cost[where] + 2;
	    cost[where] += 1;
	} else {
	    cost[n_str] = cost[where] + 1;
	    cost[where] += 2;
	}
    } 
    for (i = 0; i < N_MAX && coef[i]; i++)
	Total += cost[i] * coef[i];
}


void write_output(void)
{
    FILE *out_file = fopen(OUT_NAME, "wt");

    fprintf(out_file, "%d\n", Total);
    fclose(out_file);
}


int main(void)
{
    read_data();
    solve();
    write_output();

    return EXIT_SUCCESS;
}
