#include <stdio.h>
#include <math.h>

int N;
int L[16384];
int Y, X;
long double YS, XS;

long double angle[16384];

void angles(int split)
{
	int i;

	angle[0] = atan2(YS, XS) * 180.0 / M_PI;
	for (i = 1; i < split; i++)
		angle[i] = 0;
	angle[split] = atan2(Y - YS, X - XS) * 180.0 / M_PI;
	for (i = split + 1; i < N; i++)
		angle[i] = 0;
    if (split)
	{
		angle[split] -= angle[0];
		if (angle[split] < 0)
			angle[split] += 360;
    }
}

int test(int aA, int bB)
{
	long double C, D, E;
	long double a, b, c;
	long double delta;
	long double A, B;

	A = aA * aA;
	B = bB * bB;
	if (X != 0)
	{
		C = (A + X * X + Y * Y - B) * 0.5;
		D = C / X;
		E = Y / X;
		a = E * E + 1.0;
		b = - 2.0 * D * E;
		c = D * D - A;
		delta = b * b - 4 * a * c;
		if (delta >= 0)
		{
			XS = (- b + sqrt(delta)) / (2.0 * a);
			YS = (sqrt(A - XS * XS));
			if (fabsl(hypot(X - XS, Y - YS) - B) < 0.001)
				return 1;
            else
			{
				XS = (- b - sqrt(delta)) / (2.0 * a);
				YS = (sqrt(A - XS * XS));
            }
			return 1;
		}
		return 0;
	}
	else if (Y != 0)
	{
		return 0;
	}
	else
	{
		return A == B;
	}
}

int main(void)
{
	FILE *fp;
	int A, B;
	int i;
	
	fp = fopen("robot.in", "r");
	fscanf(fp, "%d", &N);
	A = B = 0;
	for (i = 0; i < N; i++)
	{
		fscanf(fp, "%d", &L[i]);
		B += L[i];
	}
	fscanf(fp, "%d %d", &X, &Y);
	fclose(fp);

/*	for (i = 0; i < N; i++)
	{
		if (test(A, B))
		{	
			angles(i);
			break;
		}
		A += L[i];
		B -= L[i];
	}*/
	
	fp = fopen("robot.out", "w");
/*	if (i == N)*/
		fprintf(fp, "%d\n", 0);
/*	else
		for (i = 0; i < N; i++)
			fprintf(fp, "%.4Lf\n", angle[i]);*/
	fclose(fp);

	return 0;
}

