#include <stdio.h>
#include <string.h>

#define NDEBUG

#include <assert.h>

typedef struct t_nod
{
	int na, W;
	struct t_nod *p, *l, *r;
} nod;

int f[36];
nod *list[1024];
int code[64][64];
int nl, answer;

nod *new_nod(int fr)
{
	nod *r;
	
	r = (nod *)malloc(sizeof(nod));
	r->na = fr;
	r->W = -1;
	r->p = r->l = r->r = NULL;
	return r;
}

void elim(int w)
{
	int i;

	for (i = w; i < nl - 1; i++)
		list[i] = list[i + 1];
	nl--;
}

void apply(void)
{
	int m1, m2, p1, p2, t, i;
	nod *r;
	
	m1 = list[0]->na;
	p1 = 0;
	for (i = 1; i < nl; i++)
		if (list[i]->na < m1)
		{
			m1 = list[i]->na;
			p1 = i;
		}
	m2 = list[!p1]->na;
	p2 = !p1;
	for (i = 0; i < nl; i++)
		if (list[i]->na < m2 && i != p1)
		{
			m2 = list[i]->na;
			p2 = i;
		}
	r = new_nod(m1 + m2);
	r->l = list[p1];
	r->r = list[p2];
	list[p1]->p = r;
	list[p2]->p = r;
	list[nl++] = r;
	if (p1 > p2)
		t = p1, p1 = p2, p2 = t;
	elim(p1);
	p2--;
	elim(p2);
}

int current[64];
int len;

void back(nod *r)
{
	if (r->l || r->r)
	{
		assert(r->l && r->r);
		current[len++] = 2;
		back(r->l);
		current[len - 1] = 1;
		back(r->r);
		len--;
	}
	else
	{
		assert(r->W != -1);
		memcpy(code[r->W], current, sizeof(int) * len);
		code[r->W][len] = 0;
	}
}

void free_all(nod *r)
{
	if (r)
	{
		free_all(r->l);
		free_all(r->r);
		free(r);
	}
}

int main(void)
{
	FILE *fp;
	int i, k, *c;
	
	fp = fopen("telegraf.in", "r");
	for (i = 0; i < 36; i++)
		fscanf(fp, "%d", &f[i]);
	fclose(fp);

	memset(code, 0, sizeof(code));

	k = 0;
	for (i = 0; i < 36; i++)
		if (f[i])
		{
			list[k] = new_nod(f[i]);
			list[k]->W = i;
			k++;
		}
	nl = k;

	while (nl > 1)
		apply();

	back(list[0]);

	answer = 0;
	for (i = 0; i < 36; i++)
		for (c = code[i]; *c; c++)
			answer += (*c) * f[i];

	fp = fopen("telegraf.out", "w");
	fprintf(fp, "%d\n", answer);
	fclose(fp);

	free_all(list[0]);

	return 0;
}

