#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define HugeNum 256
typedef char HugeType;
typedef HugeType *Huge;
int HugeSize=sizeof(HugeType)*HugeNum;

int N,K,P;
Huge **m;
FILE *file;

void Init(void);
void Free(void);

void Solve(void);
void _set(Huge h, int k);
void _add(Huge h1, Huge h2, Huge Res);
void _multiply(Huge h, int k, Huge Res);
void _substract(Huge h1, Huge h2, Huge Res);
void _fprint(Huge h);

int main(void)
{
 Init();
 Solve();
 Free();
 return 0;
}

void Init(void)
{
 int i,j;
 file=fopen("ex.in","r");
 fscanf(file,"%d %d %d",&N,&K,&P);
 m=malloc(sizeof(Huge*)*(N+1));
 for (i=0;i<=N;i++)
 {
  m[i]=malloc(sizeof(Huge)*(N+1));
  for (j=0;j<=N;j++)
   m[i][j]=malloc(HugeSize);
 }
 fclose(file);
 file=fopen("ex.out","w");
}

void Free(void)
{
 int i,j;
 fclose(file);
 for (i=0;i<=N;i++)
 {
  for (j=0;j<=N;j++)
   free(m[i][j]);
  free(m[i]);
 }
 free(m);
}

void Solve(void)
{
 Huge t,s;
 int i,j;
 t=malloc(HugeSize);
 s=malloc(HugeSize);
 for (i=0;i<=N;i++)
 {
  _set(m[i][0],0);
  _set(m[0][i],0);
 }
 for (i=1;i<=N;i++)
 {
  _set(m[i][1],1);
  _set(m[i][i],1);
  for (j=2;j<i;j++)
  {
   _set(m[i][j],0);
   _multiply(m[i-1][j],j,m[i][j]);
   _add(m[i-1][j-1],m[i][j],m[i][j]);
  }
 }
 _set(t,0);
 _set(s,0);
 for (i=1;i<K;i++)
  _add(m[K][i],t,t);
 _add(m[N][P],m[N-K][P-K],s);
 _substract(s,t,s);
 _fprint(s);
 free(t);
 free(s);
}

void _set(Huge h, int k)
{
 memset(h,0,HugeSize);
 while (k>0)
 {
  h[++h[0]]=k%10;
  k/=10;
 }
}

void _add(Huge h1, Huge h2, Huge Res)
{
 unsigned long i,k,t;
 if (h1[0]>h2[0])
  k=h1[0];
 else
  k=h2[0];
 t=0;
 for (i=1;i<=k;i++)
 {
  Res[i]=h1[i]+h2[i]+t;
  t=Res[i]/10;
  Res[i]%=10;
 }
 Res[0]=k;
 while (t)
 {
  Res[++Res[0]]=t%10;
  t/=10;
 }
}

void _multiply(Huge h, int k, Huge Res)
{
 unsigned long i,t;
 t=0;
 for (i=1;i<=h[0];i++)
 {
  Res[i]=h[i]*k+t;
  t=Res[i]/10;
  Res[i]%=10;
 }
 Res[0]=h[0];
 while (t)
 {
  Res[++Res[0]]=t%10;
  t/=10;
 }
}

void _substract(Huge h1, Huge h2, Huge Res)
{
 int i,t;
 t=0;
 for (i=1;i<=h2[0];i++)
 {
  if (h1[i]>=h2[i]+t)
  {
   Res[i]=h1[i]-h2[i]-t;
   t=0;
  }
  else
  {
   Res[i]=h1[i]+10-h2[i]-t;
   t=1;
  }
 }
 for (i=h2[0]+1;i<=h1[0];i++)
 {
  if (h1[i]>=t)
  {
   Res[i]=h1[i]-t;
   t=0;
  }
  else
  {
   Res[i]=h1[i]+10-t;
   t=1;
  }
 }
 Res[0]=h1[0];
 while (Res[Res[0]]==0)
  Res[0]--;
}

void _fprint(Huge h)
{
 int i;
 for (i=h[0];i>0;i--)
  fprintf(file,"%d ",h[i]);
 fprintf(file,"\n");
}