#include <stdio.h>
#include <string.h>

#define MAX(a, b) ((a) < (b) ? (b) : (a))

typedef unsigned char bigno[100];
FILE *fp;
int n, k, p;
bigno C[101][101], Comb[101][101], S, a, b;

void assign(unsigned char *a, int n)
{
	memset(a, 0, 100 * sizeof(unsigned char));
	do {
		a[0]++;
		a[a[0]] = n % 10;
		n /= 10;
	} while(n);
}

void add(unsigned char *a, unsigned char *b)
{
	int i, r;
	
	r = 0;
	for (i = 1; i <= MAX(a[0], b[0]); i++) {
		a[i] += r + b[i];
		r = a[i] / 10;
		a[i] = a[i] % 10;
	}
	
	a[0] = MAX(a[0], b[0]);
	if (r) {
		a[0]++;
		a[a[0]] = r;
	}
}

bigno c, d;
void mul(unsigned char *a, unsigned char *b)
{
	int i, j, r;

	assign((unsigned char *)d, 0);
	for (i = 1; i <= b[0]; i++) {
		memset(c, 0, 100 * sizeof(unsigned char));
		for (j = 1; j < i; j++) c[j] = 0;
		c[0] = j-1;
		r = 0;
		for (j = 1; j <= a[0]; j++) {
			c[0]++;
			c[c[0]] = b[i] * a[j] + r;
			r = c[c[0]] / 10;
			c[c[0]] %= 10;
		}
		if (r) c[++c[0]] = r;
		add((unsigned char *)d, (unsigned char *)c);
	}
	memcpy(a, d, (d[0] + 1) * sizeof(unsigned char));
}

void sub(unsigned char *a, unsigned char *b)
{
	int i, r = 0;

	for (i = 1; i <= b[0]; i++)
		if ((int)a[i] - (int)b[i] - r < 0) {
			a[i] = 10 + a[i] - b[i] - r;
			r = 1;
		}
		else {
			a[i] = a[i] - b[i] - r;
			r = 0;
		}

	do {
		if (a[i] - r >= 0) {
			a[i] -= r;
			break;
		}
		a[i] = 10 + a[i] - r;
		i++;
	} while(1);
	for (i = a[0]; !a[i]; i--, a[0]--);
}

int comp()
{
	int i, j;
	for (i = 1; i <= 100; i++) {
		assign((unsigned char *)C[1][i], i);
		assign((unsigned char *)C[i][1], 1);
	}
	
	for (i = 2; i <= 100; i++)
		for (j = 2; j <= 100; j++) {
			memcpy(C[i][j], C[i-1][j], (C[i-1][j][0] + 1) * sizeof(unsigned char));
			add((unsigned char *)C[i][j], (unsigned char *)C[i][j-1]);
//	C[i][j] = C[i-1][j] + C[i][j-1];
		}
}

void comb()
{
	int i, j;
	for (i = 1; i <= 100; i++) {
		assign((unsigned char *)Comb[i][0], 1);
		assign((unsigned char *)Comb[i][1], i);
	}
	for (i = 1; i <= 100; i++)
		for (j = 2; j <= i; j++) {
			memcpy(Comb[i][j], Comb[i][j-1], (Comb[i][j-1][0] + 1) * sizeof(unsigned char));
			add((unsigned char*)Comb[i][j], (unsigned char*)Comb[i-1][j-1]);
//	Comb[i][j] = Comb[i][k-1] + Comb[i-1][k-1]
		}

}


main()
{
	fp = fopen("ex.in", "rt");
	fscanf(fp, "%d%d%d", &n, &k, &p);
	fclose(fp);

	comp();
	comb();
	assign((unsigned char*)S, 0);
	add((unsigned char*)S, (unsigned char*)C[n-p][p-k]);
	add((unsigned char*)S, (unsigned char*)C[n-p][k]);
	mul((unsigned char*)S, (unsigned char*)Comb[n-k][p-k]);


/*	assign(a, 100);
	assign(b, 1);
	sub(a, b);*/
	fp = fopen("ex.out", "wt");
/*	for (n = S[0]; n; n--)
	printf("%d", S[n]);
	puts("");
*/

	fprintf(fp, "%d\n", 0);
	fclose(fp);
	return 0;
}
