#include <stdio.h>
#include <math.h>

#ifdef __BORLANDC__
#define maxn 1000
#define psd "%.5lf\n"
#else
#define maxn 10000
#define psd "%.5f\n"
#endif

#define pi 3.14159265358979323846

int n, i;
long len[maxn];
long x, y;
double dst1, dst2;
double eps = 1e-8;
double s1, s2, s3;
double a1, a2, a3;

void show(double angle)
{
	angle = angle * 180. / pi + 180.;
	printf(psd, angle);
}

int main(void)
{
	freopen("robot.in", "rt", stdin);
	freopen("robot.out", "wt", stdout);

	dst1 = dst2 = 0.;
	scanf("%d", &n);
	for(i = 0; i < n; i ++)
	{
		scanf("%ld", &len[i]);
		dst1 += (double)len[i];
	}

	scanf("%ld %ld", &x, &y );
	dst2 = sqrt((double)x*x + (double)y*y);
	double alfa = acos((double)x / dst2) - pi;

	// daca cele doua distantze sunt egale
	if(-eps < dst1 - dst2 && dst1 - dst2 < +eps)
	{
		show(alfa);
		for(i = 1; i < n; i ++)
			show(-pi);

		fclose(stdin);
		fclose(stdout);
		return 0;
	}
	if(-eps > dst1 - dst2)
	{
		printf("0\n");
		fclose(stdin);
		fclose(stdout);
		return 0;
	}

	int mid; s1 = 0.;
	s2 = dst1; s3 = dst2;
	for(mid = 1; mid < n; mid ++)
	{
		s1 += (double)len[mid - 1];
		s2 -= (double)len[mid - 1];

		if(s1 + s2 > s3 - eps)
			if(s1 + s3 > s2 - eps)
				if(s2 + s3 > s1 - eps)
					break;
	}

	if(mid == n)
	{
		printf("0\n");
		fclose(stdin);
		fclose(stdout);
		return 0;
	}

	#define sqr(x) ((x)*(x))
	a2 = (sqr(s2) - sqr(s1) - sqr(s3)) / (-2.*s1*s3);
	a3 = (sqr(s3) - sqr(s1) - sqr(s2)) / (-2.*s1*s2);

	a2 = acos(a2);
	a2 += alfa;
	show(a2);
	for(i = 1; i < mid; i ++)
		show(-pi);

	a3 = acos(a3);
	show(a3);
	for(i = mid + 1; i < n; i ++)
		show(-pi);

	fclose(stdin);
	fclose(stdout);
	return 0;
}
