{$I-,Q-,R-,S-}
{ limite, nume de fisiere, tipuri de date !!! }
const
  finame = 'robot.in';
  foname = 'robot.out';
  nmax = 10000; { 10000 }
var
  fi, fo: text;
  n, x, y, i, suma, total, left, right, joint, rmin, ll, rr: longint; { int64 }
  l: array[0..nmax] of longint; { int64 }
  a, b, c, cosinus, u1, u2: real;

procedure readdata;
begin
  assign(fi, finame);
  reset(fi);
  read(fi, n);
  l[0] := 0;
  total := 0;
  for i := 1 to n do
  begin
    read(fi, l[i]);
    total := total + l[i];
  end;
  read(fi, x, y);
  close(fi);
end;

function dist(x1, y1, x2, y2: longint): real;
begin
  dist := sqrt( sqr(x1-x2) + sqr(y1-y2) );
end;

function arccos(x: real): real;
begin
  if x = 0.0 then arccos := pi / 2 else
  ArcCos := ArcTan (sqrt (1-sqr (x)) /x)
end;

function grade(x: real): real;
begin
  grade := x * 180 / pi;
end;

procedure initdata;
begin
  suma := 0; rmin := maxlongint;
  for i := 0 to n do
  begin
  { primul brat e de la 0..i si celalat de la i+1..n }
    suma := suma + l[i];
    left := suma;
    right := total - suma;
    if abs(right - left) < rmin then
    begin
      joint := i;
      rmin := abs(right - left);
      ll := left; rr := right;
    end;
  end;
end;

function angle(x1, y1, x2, y2, x3, y3: longint): real;
var a, b, c, cosinus, r: real;
begin
  a := dist(x1, y1, x3, y3);
  b := dist(x1, y1, x2, y2);
  c := dist(x2, y2, x3, y2);
  cosinus := (a*a - b*b - c*c) / (2 * b * c);
  angle := grade(arccos(cosinus));
end;

procedure solvprob;
begin
  a := rr;
  b := dist(0, 0, x, y);
  c := ll;
  cosinus := (a*a - b*b - c*c) / (2 * b * c);
  u1 := abs(grade(arctan(y/x))) + abs(grade(arccos(cosinus)));
  while u1 > 360 do u1 := u1 - 360;

  a := dist(0, 0, x, y);
  b := ll;
  c := rr;

  cosinus := (a*a - b*b - c*c) / (2 * b * c);
  u2 := abs(grade(arccos(cosinus))) + 180;
  while u2 > 360 do u2 := u2 - 360;
end;

procedure writesol;
begin
  assign(fo, foname);
  rewrite(fo);
  writeln(fo, u1:0:4);
  for i := 2 to joint do
    writeln(fo, 0.0:0:4);
  writeln(fo, u2:0:4);
  for i := joint+2 to n do
    writeln(fo, 0.0:0:4);
  close(fo);
end;

procedure go_nosol;
begin
  if rmin > dist(0, 0, x, y) then
  begin
    assign(fo, foname);
    rewrite(fo);
    writeln(fo, 0);
    close(fo);
    halt(0);
  end;
end;

begin
  readdata;
  initdata;
  go_nosol;
  solvprob;
  writesol;
end.
