#include <stdio.h>

#define	MAXN			100
#define	MAXK			100
#define	MAXP			100
#define	MAXC			125
#define	BAZA			10000L

struct NR
{
	int nc;
	long c[MAXC];
} nr[MAXN+1][MAXP+1], nt1;

int n, k, p;

void init( struct NR *na, long val )
{
	for( ; val ; val /= BAZA )
		na->c[na->nc++] = (val%BAZA);
}

void copiere( struct NR *na, struct NR *nb )
{
	int i;

	for( i = 0 ; i < na->nc ; i++ )
		na->c[i] = 0;
	na->nc = nb->nc;
	for( i = 0 ; i < na->nc ; i++ )
		na->c[i] = nb->c[i];
}

void aduna( struct NR *na, struct NR *nb )
{
	int i;
	long t, tt;

	if( nb->nc > na->nc )
		na->nc = nb->nc;
	for( i = t = 0 ; i < na->nc ; i++ )
	{
		tt = t;
		t = (na->c[i]+nb->c[i]+tt)/BAZA;
		na->c[i] = (na->c[i]+nb->c[i]+tt)%BAZA;
	}
	for( ; t ; t /= BAZA )
		na->c[na->nc++] = t%BAZA;
}

void inmult_val( struct NR *na, long val )
{
	int i;
	long t, tt;

	for( i = t = 0 ; i < na->nc ; i++ )
	{
		tt = t;
		t = ((na->c[i]*val)+tt)/BAZA;
		na->c[i] = ((na->c[i]*val)+tt)%BAZA;
	}
	for( ; t ; t /= BAZA )
		na->c[na->nc++] = t%BAZA;
}

void scrie( struct NR *na )
{
	int i;

	printf( "%ld", na->c[na->nc-1] );
	for( i = na->nc-2 ; i >= 0 ; i-- )
		printf( "%04ld", na->c[i] );
	printf( "\n" );
}

int main( )
{
	int i, j;

	freopen( "ex.in", "r", stdin );
	scanf( "%d%d%d", &n, &k, &p );
	fclose( stdin );

	init( &nr[k][k], 1 );
	for( i = k ; i <= n ; i++ )
		for( j = k ; j <= p ; j++ )
			if( i != k || j != k )
			{
				init( &nr[i][j], 0 );
				copiere( &nt1, &nr[i-1][j] );
				inmult_val( &nt1, j );
				aduna( &nr[i][j], &nt1 );
				copiere( &nt1, &nr[i-1][j-1] );
				inmult_val( &nt1, j-k );
				aduna( &nr[i][j], &nt1 );
			}

	freopen( "ex.out", "w", stdout );
	scrie( &nr[n][p] );
	fclose( stdout );
	return 0;
}
