#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define	MAXN				10000
#define	MAXNIV			15
#ifndef	min
#define	min( a,  b )		( (a)<(b)?(a):(b) )
#endif

struct DIST
{
	long dmin, dmax;
} di[MAXN][MAXNIV], df[MAXN][MAXNIV];

struct PUNCT
{
	double x, y;
} pp[MAXN];

int n;
int l[MAXN];
long xp, yp;

struct DIST div_imp1( int a, int b, int niv )
{
	struct DIST d1, d2, dr;
	int m, i, j;

	if( a == b )
	{
		dr.dmin = dr.dmax = l[a];
		di[a][niv] = df[a][niv] = dr;
		return dr;
	}

	m = (a+b)>>1;
	d1 = div_imp1( a, m, niv+1 );
	d2 = div_imp1( m+1, b, niv+1 );

	if( d1.dmin > d2.dmin )
	{
		dr = d1;
		d1 = d2;
		d2 = dr;
	}
	if( d2.dmin <= d1.dmax )
		dr.dmin = 0;
	else
		dr.dmin = d2.dmin-d1.dmax;

	dr.dmax = d1.dmax+d2.dmax;
	di[a][niv] = dr;
	df[a][niv] = dr;
	return dr;
}

void div_imp2( int a, int b, struct PUNCT *pa, struct PUNCT *pb )
{
	struct DIST d1, d2;

	if( a == b )
	{
		pp[a].x = pa->x;
		pp[a].y = pa->y;
		return;
	}


}

int main( )
{
	int i;
	struct DIST d1;
	struct PUNCT p1, p2;
	long dc;

	freopen( "robot.in", "r", stdin );
	scanf( "%d", &n );
	for( i = 0 ; i < n ; i++ )
		scanf( "%d", &l[i] );
	scanf( "%ld%ld", &xp, &yp );
	fclose( stdin );

	freopen( "robot.out", "w", stdout );
	d1 = div_imp1( 0, n-1, 0 );
	dc = xp*xp+yp*yp;
	if( dc < d1.dmin*d1.dmin || dc > d1.dmax*d1.dmax )
		printf( "0\n" );
	else
	{
		p1.x = p1.y = 0;
		p2.x = xp;
		p2.y = yp;
		div_imp2( 0, n-1, &p1, &p2 );
	}
	fclose( stdout );

	return 0;
}
