#include <stdio.h>

#define  DIGITS    60
#define  BASE   10000

struct bignum {
    long dig[DIGITS], n;
};

typedef struct bignum BIGNUM, *PBIGNUM;

void init(BIGNUM &a, long z)
{
    int i;
    if(z==0) {
	a.dig[0]=0;
	a.n=1;
	return;
    }
    for(i=0;z;i++) {
	a.dig[i]=z%BASE;
	z/=BASE;
    }
    a.n=i;
}

void add(BIGNUM &z, BIGNUM &a)
{
    int i; long carry;
    for(i=0;i<a.n;i++)
	if(i>=z.n)
	    z.dig[i]=a.dig[i];
	else
	    z.dig[i]+=a.dig[i];
    if(a.n>z.n)
	z.n=a.n;
    for(i=0, carry=0;(i<z.n)||(carry);i++) {
	carry+=z.dig[i];
	z.dig[i]=carry%BASE;
	carry/=BASE;
    }
    z.n=i;
}

void mult(BIGNUM &z, long a)
{
    int i; long carry;
    for(i=0;i<z.n;i++)
	z.dig[i]*=a;
    for(i=0, carry=0;(i<z.n)||(carry);i++) {
	carry+=z.dig[i];
	z.dig[i]=carry%BASE;
	carry/=BASE;
    }
    z.n=i;
}

void print(BIGNUM &z, char *s)
{
    char buf[8]; int i, j;
    if(z.n==0)
	z.dig[z.n++]=0;
    for(i=z.n-1;(i>0)&&(z.dig[i]==0);i--);
    z.n=i+1;
    for(i=z.n-1;i>=0;i--) {
	if(i==(z.n-1))
	    sprintf(buf, "%ld", z.dig[i]);
	else
	    sprintf(buf, "%4ld", z.dig[i]);
	for(j=0;buf[j];j++) {
	    if(buf[j]==' ')
		buf[j]='0';
	    *s=buf[j];
	    s++;
	}
    }
    *s=0;
}


int N, K, P;

void init(void)
{
    FILE *pf;
    pf=fopen("ex.in", "rt");
    fscanf(pf, "%d %d %d", &N, &K, &P);
    fclose(pf);
}

BIGNUM c[102][102], sol;

void solve(void)
{
    int i, j, k; FILE *pf; char buf[1024];
    if(K>P)
	init(sol, 0);
    else {
    	for(j=0;j<=P+1;j++)
	    init(c[0][j], 0);
	init(c[0][P-K], 1); N-=K;
	for(i=1;i<=N;i++)
	    for(j=0;j<=P;j++) {
		init(c[i][j], 0);
		c[i][j]=c[i-1][j];
		mult(c[i][j], P-j);
		add(c[i][j], c[i-1][j+1]);
	    }	
	sol=c[N][0];
    }
    pf=fopen("ex.out", "wt");
    print(sol, buf);
    fprintf(pf, "%s\n", buf);
    fclose(pf);
}

int main(void)
{
    init();
    solve();
    return 0;
}
