#include <stdio.h>

struct _simbol {
    int s[37], l;
    long val;
};

typedef struct _simbol SIMBOL, *PSIMBOL;

SIMBOL table[128];
int ns;

long cost(SIMBOL z)
{
    int i; long rv;
    for(i=0, rv=0;i<z.l;i++)
	rv+=z.s[i];
    return rv;
}

/* z este un prefix pt w ? */
int prefix(SIMBOL &z, SIMBOL &w)
{
    int i;
    if(w.l<z.l)
	return 0;
    for(i=0;i<z.l;i++)
	if(z.s[i]!=w.s[i])
	    return 0;
    return 1;
}

int egal(SIMBOL &z, SIMBOL &w)
{
    int i;
    if(w.l!=z.l)
	return 0;
    for(i=0;i<z.l;i++)
	if(z.s[i]!=w.s[i])
	    return 0;
    return 1;
}

#define INF 1000000000l
long cost_adaugare(SIMBOL z)
{
    int i, sw; long rv, val, cz;
    for(i=0;i<ns;i++)
	if(prefix(table[i], z))
	    if(egal(table[i], z)==0)
	        return INF;
    for(i=0, val=0, sw=0;i<ns;i++)
	if(prefix(z, table[i])) {
	    sw=1;
	    val+=table[i].val;
	}
    cz=cost(z);
    if(sw) {
	if(val*2+(cz+1)*z.val > val+(cz+2)*z.val )
	    return val+(cz+2)*z.val;
	else
	    return val*2+(cz+1)*z.val;
    } else
	return cz*z.val;
}

void adauga(SIMBOL z)
{
    int i, sw, vz, j;
    long rv, val, cz;
    for(i=0, val=0, sw=0;i<ns;i++)
	if(prefix(z, table[i])) {
	    sw=1;
	    val+=table[i].val;
	}
    cz=cost(z);
    if(sw) {
	if(val*2+(cz+1)*z.val > val+(cz+2)*z.val )
	    vz=2;
	else
	    vz=1;
	for(i=0, val=0, sw=0;i<ns;i++)
	    if(prefix(z, table[i])) {
		for(j=table[i].l;j>z.l;j--)
		    table[i].s[j]=table[i].s[j-1];
		table[i].s[z.l]= (vz==1 ? 2 : 1);
		table[i].l++;
	    }
	z.s[z.l++]=vz;
    }
    table[ns++]=z;
}

SIMBOL simb[8193];
long nsimb;
SIMBOL x;

void _generare_simb(int dpth)
{
    int i;
    if(dpth==x.l) 
	simb[nsimb++]=x;
    else {
	x.s[dpth]=1;
	_generare_simb(dpth+1);
	x.s[dpth]=2;
	_generare_simb(dpth+1);
    }
}

void generare_simb(void)
{
    int i;
    for(i=1;i<12;i++) {
	x.l=i;
	_generare_simb(0);
    }
}

long freq[36], nf;

void init(void)
{
    int i, j;
    FILE *pf;
    pf=fopen("telegraf.in", "rt");
    for(i=0;i<36;i++) {
        fscanf(pf, "%ld", &freq[nf]);
	if(freq[nf])
	    nf++;
    }
    for(i=0;i<nf;i++)
	for(j=i+1;j<nf;j++)
	    if(freq[i]<freq[j]) {
		long t=freq[i]; freq[i]=freq[j]; freq[j]=t;
	    }
    fclose(pf);
}

void solve(void)
{
    int i, j, mpos;
    long min, cur, sol;
    FILE *pf;
    
    for(i=0;i<nf;i++) {
	SIMBOL nou;
	for(j=0, min=INF;j<nsimb;j++) {
	    nou=simb[j]; nou.val=freq[i];
	    if(min>(cur=cost_adaugare(nou))) {
		min=cur; mpos=j;
	    }
	}
	nou=simb[mpos]; nou.val=freq[i];
	adauga(nou);
    }
    for(i=0, sol=0;i<ns;i++)
	sol+=table[i].val*cost(table[i]);
    pf=fopen("telegraf.out", "wt");
    fprintf(pf, "%ld\n", sol);
    fclose(pf);
}

int main(void)
{
    init();
    generare_simb();
    solve();
    return 0;
}
