#include <fstream.h>

ifstream in("ex.in");
ofstream out("ex.out");

#if !defined(__BORLANDC__)
#define MAXD 120
#define MAX 102
#else
#define MAXD 30
#define MAX 20
#endif

class LNumber
 {
  public:
   unsigned int digits[MAXD];
   int nd;

   LNumber()
    {
     nd=0;
     int i;
     for(i=0;i<MAXD;i++) digits[i]=0;
    }

    LNumber(long a)
     {
      int i=0;
      while(a)
       {
	digits[i]=a%10;
	a/=10;
	i++;
       }
      if(i==0) nd=0;
      else nd=i;
     }

   LNumber operator+(LNumber b)
    {
     LNumber R;
     if(b.nd==0) return *this;
     if(nd==0) return b;
     int i,l;
     l=nd;
     if(b.nd>l) l=b.nd;
     l++;
     for(i=0;i<l;i++) R.digits[i]=0;
     for(i=0;i<l;i++)
      {
       R.digits[i]+=digits[i]+b.digits[i];
       if(R.digits[i]>9) {R.digits[i]-=10;R.digits[i+1]++;}
      }
     if(R.digits[l-1]!=0) R.nd=l;
     else R.nd=l-1;
     return R;
    }

    LNumber operator*(LNumber a)
     {
      LNumber R;
      if(nd==0 || a.nd==0) return R;
      R.nd=nd+a.nd;
      int i,j;
      for(i=0;i<nd;i++)
       for(j=0;j<a.nd;j++)
	{
	 R.digits[i+j]+=digits[i]*a.digits[j];
	 if(R.digits[i+j]>200)
	  {
	   int t=R.digits[i+j];
	   R.digits[i+j]=t%10;
	   R.digits[i+j+1]+=t/10;
	  }
	}
       for(i=0;i<R.nd;i++)
	{
	 int t=R.digits[i];
	 if(t>9) {R.digits[i]=t%10;R.digits[i+1]+=t/10;}
	}
       if(R.digits[R.nd-1]==0)
	R.nd--;
       return R;
     }

    void operator=(LNumber b)
     {
      nd=b.nd;
      int i;
      for(i=0;i<b.nd;i++) digits[i]=b.digits[i];
     }
 };

LNumber zero,unu;

int N,K,P;

LNumber comb[MAX][MAX];
LNumber fact[MAX];

LNumber p[MAX][MAX];

void CalcComb()
 {
  int i, j;
  for(i=0;i<=N;i++)
   {
   for(j=0;j<=N;j++)
    comb[i][j]=zero;
   comb[i][0]=unu;
   }
  for(i=1;i<=N;i++)
   for(j=1;j<=N;j++)
    {
     LNumber r1=comb[i-1][j];
     LNumber r2=comb[i-1][j-1];
     LNumber R=r1+r2;
     comb[i][j]=R;
    }
 }

void CalcFact()
 {
  fact[0]=1;
  int i;
  for(i=1;i<=K;i++)
   {
    LNumber t;
    t=i;//!!
    LNumber R=fact[i-1]*t;
    fact[i]=R;
   }
 }

void CalcP()
 {
  int i,j,l;
  for(i=0;i<=N;i++)
   for(j=0;j<=P;j++)
    p[i][j]=zero;
  p[0][0]=unu;
  for(i=1;i<=N;i++)
   for(j=1;j<=P;j++)
    {
     LNumber R,r;
     R=zero;
     for(l=1;l<=i;l++)
      {
       r=comb[i-1][l-1]*p[i-l][j-1];
       R=R+r;
      }
     p[i][j]=R;
    }
 }

void Print(LNumber a)
 {
  int l=a.nd;
  l--;
  while(l>=0)
   {
    out<<((int)a.digits[l]);
    l--;
   }
  out<<"\n";
 }

int main()
 {
  zero.nd=0;
  unu.nd=1;
  unu.digits[0]=1;
  in>>N>>K>>P;
  if(P<K) {out<<0<<"\n";return 0;}
  if(N==K) {out<<1<<"\n";return 0;}
  CalcComb();
  CalcFact();
  CalcP();
  int g;
  LNumber R,r;
  R=zero;

  for(g=0;g<=K;g++)
   {
    r=comb[K][g]*comb[P-K+g][g]*fact[g];
    r=r*p[N-K][P-K+g];
    R=R+r;
   }

  Print(R);
  return 0;
 }