#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define min(a,b) a<=b?a:b
#define max(a,b) a>=b?a:b

#define degsin(a) sin(a*M_PI/180.0)
#define degcos(a) cos(a*M_PI/180.0)

int n, l[10000], step, level;
unsigned long s1, s2;
long x, y;
double u1, u2, b1, b2, xf, yf, r1, r2;

void no_solution()
  {
  FILE *f = fopen("robot.out", "w");
  fprintf(f, "0\n");
  fclose(f);
  exit(0);
  }

double getangle(double from_x, double from_y)
  {
  double sn, cs, angle;
  cs = (xf - from_x) / s2;
  sn = (yf - from_y) / s2;
  angle = asin(sn);
  if (angle > 0)
      angle = acos(cs);
    else
      angle = -acos(cs);
  return (angle*180.0/M_PI);
  }

void solutie(double sol)
  {
  FILE *f = fopen("robot.out", "w");
  fprintf(f, "%f", sol);
  fprintf(f, "\n");
  int i;
  for (i = 1; i < step; i++)
    fprintf(f, "0\n");
  u2 = getangle(0, 0);
  fprintf(f, "%f\n", u2);
  for (i = step+1; i < n; i++)
    fprintf(f, "0\n");
  fclose(f);
  exit(0);
  }

void srch(double step_size)
  {
  if (step_size >= 0.00001)
    {
    double ss, a, b, r;
    ss = b1 + step_size;
    a = degcos(ss) * s1;
    b = degsin(ss) * s1;
    r = sqrt((xf-a)*(xf-a) + (yf-b)*(yf-b));
    if (r - s2 <= 0.0005)
      solutie(ss);
    if (r - s2 < 0)
	{
	if (r1 - s2 >= 0)
	    {
	    b2 = ss;  r2 = r;
	    srch(step_size/2);
	    }
	  else
	    {
	    b1 = ss;  r1 = r;
	    srch(step_size/2);
	    }
	}
      else
	{
	if (r1 - s2 <= 0)
	    {
	    b2 = ss;
	    srch(step_size/2);
	    }
	  else
	    {
	    b1 = ss;
	    srch(step_size/2);
	    }
	}
    }
  }
/*{
if (step_size >= 0.00001)
  {
  double s1, s2, ss, a, b, r;
  ss = b1;  s1 = -1.0;  s2 = -1.0;
  while (ss <= b2)
    {
    a = degcos(ss) * s1;
    b = degsin(ss) * s1;
    r = sqrt((xf-a)*(xf-a) + (yf-b)*(yf-b));
    if (r <= 0.0005)
      solutie(ss);
    if (r - s2 < 0)
	{
	s1 = ss;
	if (s2 != -1.0)
	  {
	  b1 = min(s1, s2);
	  b2 = max(s1, s2);
	  srch(step_size/10);
	  s1 = -1.0;
	  s2 = -1.0;
	  }
	}
      else
	{
	s2 = ss;
	if (s1 != -1.0)
	  {
	  b1 = min(s1, s2);
	  b2 = max(s1, s2);
	  srch(step_size/10);
	  s1 = -1.0;
	  s2 = -1.0;
	  }
	}
    ss += step_size;
    }
  }
}
*/

int main()
  {
  FILE *f = fopen("robot.in", "r");
  fscanf(f, "%d", &n);
  int i;
  fscanf(f, "%ld", &s1);
  l[0] = s1;
  for (i = 1; i < n; i++)
    {
    fscanf(f, "%d", &l[i]);
    s2 += l[i];
    }
  fscanf(f, "%ld %ld", &x, &y);
  fclose(f);
  if ((x*x+y*y)>(s1+s2)*(s1+s2) + 0.001)
    {
    no_solution();
    exit(0);
    }
  if ((x*x+y*y)>(s1+s2)*(s1+s2) - 0.001)
    {
    u1 = getangle(0, 0);
    f = fopen("robot.out", "w");
    fprintf(f, "%f\n", u1);
    for (i = 1; i < n; i++)
      fprintf(f, "0\n");
    exit(0);
    }
  // real math
  xf = x;  yf = y;
  double af, a, b, r;
  step = 1;
  do {
    b1 = -1.0;
    b2 = -1.0;
    for (af = 0.0; af <= 360.0; af += 1.0)
      {
      a = degcos(af) * s1;
      b = degsin(af) * s1;
      r = sqrt((xf-a)*(xf-a) + (yf-b)*(yf-b));
      if (r-s2 < 0)
	  {
	  b1 = af;  r1 = r;
	  if (b2 != -1.0)
	    {
	    if (b1 > b2)
	      {
	      b1 = b2;
	      b2 = af;
	      }
	    srch(0.5);
	    b1 = -1.0;
	    b2 = -1.0;
	    }
	  }
	else
	  {
	  b2 = af;  r2 = r;
	  if (b1 != -1.0)
	    {
	    if (b1 > b2)
	      {
	      b2 = b1;
	      b1 = af;
	      }
	    srch(0.5);
	    b1 = -1.0;
	    b2 = -1.0;
	    }
	  }
      }
    s1 += l[step];
    s2 -= l[step];
    step++;
    } while (step < n);
  return 0;
  }