#include <fstream.h>

#define InFile "telegraf.in"
#define OutFile "telegraf.out"
#define Max 38


long d1[] = {2, 1,2};
long d2[] = {4, 11,12,21,22};
long d3[] = {8, 111,112,121,211,122,212,221,222};
long d4[] = {16, 1111,1112,1121,1211,2111,1212,1221,1122,2112,2121,2211,2122,1222,2212,2221,2222};
long d5[] = {32, 11111,11112,11121,11211,12111,21111,11221,11122,12112,12121,12211,11212,21112,21121,21211,22111,11222,12212,21122,12221,21212,21221,12122,22112,22121,22211,12222,22122,21222,22212,22221,22222};
long d6[] = {64, 111111,111112,111121,111211,112111,121111,211111,111122,112112,112121,112211,111212,121112,121121,121211,122111,111221,211112,211121,211211,212111,221111,112122,122112,122121,122211,111222,112212,121122,211122,112221,211212,211221,121212,212112,212121,212211,121221,221112,221121,221211,222111,212122,112222,212212,212221,122122,211222,121222,221122,122212,221212,221221,122221,222112,222121,222211,122222,221222,222122,212222,222212,222221,222222};
long frq[Max];
long ff[Max];
char used[22223];


int sDigits ( long a )   /* Sum of digits */
{
	int sum = 0;
	while ( a )
	{
		sum += a%10;
		a /= 10;
	}
	return sum;

}

int nDigits ( long a )  /* Number of digits */
{
	int num = 0;
	while ( a )
	{
		num ++;
		a /= 10;
	}
	return num;
}

long pow ( long a, int b )
{
	long aux = 0;
	long t;
	t = a;
	if ( b == 0 ) return 1;
	else
	{
		for ( aux = 1; aux < b; aux++ )
			a *= t;
		return a;
	}
}


void ReadData ()
{
	ifstream fin ( InFile );
	int i, j;

	for ( i = 1; i <= 36; i++ )
	{
		fin >> frq[i];
		if ( frq[i] )
			ff[++ff[0]] = frq[i];
	}

	for ( i = 1; i < ff[0]; i++ )
		for ( j = i+1; j <= ff[0]; j++ )
			if ( ff[i] < ff[j] )
			{
				long aux;
				aux = ff[i];
				ff[i] = ff[j];
				ff[j] = aux;
			}
	fin.close ();
}



int Try ( long & a, int i )
{
	int t = 0, dg, q = 0;
	long aux = 0, tm;
	tm = a;
	while ( tm != 0 )
	{
		dg = tm%10;
		tm /= 10;
		if ( t != i )
		{
			aux += pow (10,q)*dg;
			q++;
		}
		t++;
	}

	used [a/10] --;
	if ( used[aux] == 0 )
	{
		a = aux;
		used[a]++;
		return 1;
	}
	else used [a/10] ++;
	return 0;
}


void Solve ( long s [] )
{
	int i, j;
	if ( ff[0] != s[0] )
	{
		for ( i = 1; i <= ff[0]; i++ )
			used [ s[i]/10 ] ++;

		for ( i = ff[0]; i >= 1; i-- )
			for ( j = 0; j < nDigits(s[i]); j++ )
			if ( (s[i]/pow(10, j))%10 == 2 )
				{
					Try ( s[i], j );
				}

		for ( i = ff[0]; i >= 1; i-- )
			for ( j = 0; j < nDigits(s[i]); j++ )
				if ( (s[i]/pow(10, j))%10 == 1 )
				{
					if (Try ( s[i], j ))
						break;
				}
	}

	for ( i = 1; i < ff[0]; i++ )
		for ( j = i+1; j <= ff[0]; j++ )
			if ( sDigits(s[i]) > sDigits(s[j]) )
			{
				long aux;
				aux = s[i];
				s[i] = s[j];
				s[j] = aux;
			}

	long sum = 0;
	for ( i = 1; i <= ff[0]; i++ )
		sum += ff[i] * sDigits(s[i]);
	ofstream fout ( OutFile );
	fout << sum;
	fout.close ();
}


int main ()
{
	ReadData ();
	if ( ff[0] > 32 ) Solve ( d6 );
	else if ( ff[0] > 16 ) Solve ( d5 );
	else if ( ff[0] > 8 ) Solve ( d4 );
	else if ( ff[0] > 4 ) Solve ( d3 );
	else if ( ff[0] > 2 ) Solve ( d2 );
	else Solve ( d1 );

	return 0;
}
