#include <stdio.h>
#include <string.h>

#define RADIX 10000
#define NUMLEN 101

int N, K, P;
int A[101][NUMLEN], B[101][NUMLEN];

void add(int *a, int *b)
{
    int i, carry = 0;
    
    if (a[0] < b[0]) a[0] = b[0];
    for (i = 1; i <= a[0]; i++)
    {
        a[i] += b[i] + carry;
        carry = a[i] / RADIX;
        a[i] %= RADIX;
    }
    if (carry) a[++a[0]] = carry;
}

void multiply(int *a, int b)
{
    int i, carry = 0;

    for (i = 1; i <= a[0]; i++)
    {
        a[i] = a[i] * b + carry;
        carry = a[i] / RADIX;
        a[i] %= RADIX;
    }
    while (carry)
          a[++a[0]] = carry % RADIX,
          carry /= RADIX;
}

void read()
{
    FILE *f;

    f = fopen("ex.in", "r");
    fscanf(f, "%d %d %d\n", &N, &K, &P);
    fclose(f);
}

void solve()
{
    int i, j;
    
    A[K][0] = A[K][1] = 1;
    for (i = 1; i <= N - K; i++)
    {
        for (j = 1; j <= P; j++)
            add(B[j], A[j]),
            multiply(B[j], j),
            add(B[j], A[j - 1]);
            
        memcpy(A, B, sizeof(B));
        memset(B, 0, sizeof(B));
    }
}

void write()
{
    FILE *f;
    int i;

    f = fopen("ex.out", "w");
    fprintf(f, "%d", A[P][A[P][0]]);
    for (i = A[P][0] - 1; i; i--)
        fprintf(f, "%04d", A[P][i]);
    fprintf(f, "\n");
    fclose(f);
}

int main()
{
    read();
    solve();
    write();
    return 0;
}
