\
#include <stdio.h>
#include <mem.h>
#include <math.h>

FILE *fi;

const int compl[4] = {3, 2, 1, 0};


typedef struct mask
{
	unsigned char x[60];
} mask;

typedef struct salv
{
	int x, y;
	mask m[4];
} salv;

int n;
long m;

salv *s;

void nullmask(mask *m)
{
	memset(m, 0, sizeof(mask));
}

void makemask(mask *m)
{
	memset(m, 255, sizeof(mask));
}

void input()
{
	fscanf(fi, "%d%d", &n, &m);
	s = new salv[n];

	for (int i=0;i<n;i++)
	{
		fscanf(fi, "%d%d", &s[i].x, &s[i].y);
	}
}

int getnextfmask(mask *m)
{
	int i;

	for (i=0;i<n;i++)
	{
		if (m->x[i/8] & (1 << (i%8))) return i;
	}
	return -1;
}

void killbit(mask *m, int bit)
{
	m->x[bit/8] &= 0xFF - (1 << (bit%8));
}

void andmask(mask *m1, mask *m2)
{
	for (int i=0;i<51;i++)
	{
		m1->x[i] = m1->x[i] & m2->x[i];
	}
}

void calcmasks()
{

	int i, j, k;

	int cs, cj, cad;
	int dx, dy;

	for (i=0;i<n;i++)
	{
		for (j=0;j<n;j++)
		{
			if (s[i].x>s[j].x) cs = 1; else cs=0;
			if (s[i].y<s[j].y) cj = 1; else cj=0;
			cad = cs+cj*2;
			dx = abs(s[i].x - s[j].x);
			dy = abs(s[i].y - s[j].y);

			for (k=0;k<4;k++)
			{
				if ((k!=compl[cad])||(i==j)||(dx==1)||(dy==0))
				{
					s[i].m[k].x[j/8] |=        (1 << (j%8));
				} else {
					s[i].m[k].x[j/8] &= 0xFF - (1 << (j%8));
				}
			}
		}
	}
}

int main()
{
	fi = fopen("ajutor.in","r");
	input();

	calcmasks();

	FILE *fo = fopen("ajutor.out", "w");

	int x, y;
	long md, cd;

	mask cm;

	long i, j;
	int cs, cj, cad;

	for (i=0;i<m;i++)
	{
		fscanf(fi, "%d%d", &x, &y);
		md = 65000;
		makemask(&cm);

		do
		{
			j=getnextfmask(&cm);
			if (j==-1) break;

			if ( (x==s[j].x)&&(y==s[j].y) ) { md=0; break; }

			cd = labs(s[j].x - x) + labs(s[j].y - y);
			if (cd<md) md = cd;

			if (x<s[j].x) cs = 1; else cs=0;
			if (y<s[j].y) cj = 1; else cj=0;

			cad = cs+cj*2;

			andmask(&cm, &s[j].m[compl[cad]]);

			killbit(&cm, j);

		} while (1);

		fprintf(fo, "%d\n", md);
	}

	fclose(fo);
	fclose(fi);

	delete[] s;

	return 0;
}