#include <stdio.h>
#include <math.h>

typedef struct _POST
{
  struct _POST *prev, *next;
  int i;
} POST;

FILE *f, *g;

POST *px, *py;
long n, m;
int x[410];
int y[410];
POST **cx, **cy;

int adaugax(int i)
{
  POST *t;
  t = new POST;
  t->next = px;
  if (px) px->prev = t;
  t->prev = 0;
  t->i = i;
  px = t;
  return 0;
}

int adaugay(int i)
{
  POST *t;
  t = new POST;
  t->next = py;
  if (py) py->prev = t;
  t->prev = 0;
  t->i = i;
  py = t;
  return 0;
}

int init()
{
  cx = new POST *[3200];
  cy = new POST *[3200];

  f = fopen("ajutor.in", "r");
  g = fopen("ajutor.out", "w");
  fscanf(f, "%d %d", &n, &m);

  for (int i=1; i<=n; i++)
  {
    fscanf(f, "%d %d", &x[i], &y[i]);
    adaugax(i);
    adaugay(i);
  }
  return 0;
}

int uninit()
{
  fclose(f);
  fclose(g);
  return 0;
}

int sort(POST *px, int *x)
{
  int sorted;
  do
  {
    sorted = 1;
    POST *p = px;

    while (p->next)
    {
      if (x[p->i] > x[p->next->i])
      {
	int i = p->i;
	p->i = p->next->i;
	p->next->i = i;
	sorted = 0;
      }
      p = p->next;
    }
  } while (!sorted);

  return 0;
}

int cache(POST *px, int *x, POST **cx)
{
  int i, xi, xf;

  xf = 0;
  while (px)
  {
    xi = xf;
    if (px->next) xf = x[px->next->i]/10;
    else xf = 3201;

    for (i=xi; i<xf; i++) cx[i] = px;
    px = px->next;
  }

  return 0;
}

long getdist(int x0, int y0)
{
  POST *pn, *pv, *pe, *ps;

  pn = ps = cy[y0/10];
  pv = pe = cx[x0/10];

  long dist = 100000;
  long d,xm,ym;
  int i;
  int dirc = 4;
  while (dirc)
  {
    if (pn)
    {
      i = pn->i;
      xm = abs(x[i]-x0);
      ym = abs(y[i]-y0);
      d = xm+ym;

      if (d<dist) dist = d;

      if (ym>dist) pn = 0;
      else pn = pn->prev;
      if (!pn) dirc--;
    }
    if (ps)
    {
      i = ps->i;
      xm = abs(x[i]-x0);
      ym = abs(y[i]-y0);
      d = xm+ym;

      if (d<dist) dist = d;

      if (ym>dist) ps = 0;
      else ps = ps->next;
      if (!ps) dirc--;
    }
    if (pv)
    {
      i = pv->i;
      xm = abs(x[i]-x0);
      ym = abs(y[i]-y0);
      d = xm+ym;

      if (d<dist) dist = d;

      if (xm>dist) pv = 0;
      else pv = pv->prev;
      if (!pv) dirc--;
    }
    if (pe)
    {
      i = pe->i;
      xm = abs(x[i]-x0);
      ym = abs(y[i]-y0);
      d = xm+ym;

      if (d<dist) dist = d;

      if (xm>dist) pe = 0;
      else pe = pe->next;
      if (!pe) dirc--;
    }
  }

  return dist;
}

int writeout()
{
  for (long i=1; i<=m; i++)
  {
    int x, y;
    fscanf(f, "%d %d", &x, &y);
    fprintf(g, "%ld\n", getdist(x,y));
  }
  return 0;
}

int main()
{
  init();
  sort(px, (int *)&x);
  sort(py, (int *)&y);
  cache(px, (int *)&x, cx);
  cache(py, (int *)&y, cy);
  writeout();
  uninit();
  return 0;
}