#include <stdio.h>
#include <string.h>

#define maxc 400
#define base 10

typedef int num_t[maxc];

void add(num_t A, num_t B)
{
    int i, t = 0;
    for (i = 1; i <= A[0] || i <= B[0] || t; i++, t /= base)
        A[i] = (t += A[i]+B[i]) % base;
    A[0] = i-1;
}

void mul(num_t A, int x)
{
    int i, t = 0;
    for (i = 1; i <= A[0] || t; i++, t /= base)
        A[i] = (t += A[i]*x) % base;
    A[0] = i-1;
}

void mul2(num_t A, num_t B, num_t R)
{
    int i, j, t = 0; /* !!t can be as much as maxc*maxc*base!! */
    for (i = 1; i <= A[0]+B[0]+1 || t; R[i++] = t % base, t /= base)
        for (j = 1; j <= i; j++)
            t += A[j] * B[i-j+1];
    for (R[0] = i; R[0] > 1 && !R[R[0]]; R[0]--);
}

int div(num_t A, int x)
{
    int i, r = 0;
    for (i = A[0]; i > 0; i--, r %= x)
        A[i] = (r = r * base + A[i]) / x;
        
    for (; A[0] > 1 && !A[A[0]]; A[0]--);
    return r;
}

num_t N, X, T, R, T1 = {1, 1};

void as_vrea_sa_pot_da_timpul_inapoi_perdona_me_ti_prego()
{
    int r;

    memcpy(X, N, sizeof(num_t));
    mul(X, 2);
    add(X, T1);
    r = div(X, 3);
    memcpy(T, X, sizeof(num_t));
    add(T, T1);
    mul2(X, T, R);
    div(R, 2);
    if (r == 2)
       add(R, X);
    
    div(X, 2);
    memset(T, 0, sizeof(T));
    mul2(X, X, T);
    add(R, T);
}

void in_urma_ta_raman_mereu_franturi_de_ego()
{
    int i;
    FILE *fi = fopen("sala.in", "rt");
    fscanf(fi, "%d", N);
    for (i = N[0]; i > 0; i--)
        fscanf(fi, "%d", N+i);
    fclose(fi);
}

void tata_in_lumea_asta_scurta_si_inceata_sa_fim_ca_altadata_amandoi()
{
    int i;
    FILE *fo = fopen("sala.out", "wt");
    for (i = R[0]; i > 0; i--)
        fprintf(fo, "%d", R[i]);
    fprintf(fo, "\n");
    fclose(fo);
}

int main()
{
    in_urma_ta_raman_mereu_franturi_de_ego();
    as_vrea_sa_pot_da_timpul_inapoi_perdona_me_ti_prego();
    tata_in_lumea_asta_scurta_si_inceata_sa_fim_ca_altadata_amandoi();
    return 0;
}


