#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __BORLANDC__
#define N_GUIDES 5000
#define T_MAX		128
#else
#define N_GUIDES 5000
#define T_MAX		128
#define far
#endif

int ecap[T_MAX][T_MAX], far eflow[T_MAX][T_MAX];

int far q[T_MAX], df_pi[T_MAX];
char vflags[T_MAX];
void do_flow(int v, int s, int d) {
	int mf, cf;
	int x, qin, qout;
	int cv;

	while(1) {
		// do bf
		q[0] = s; qin = 1; qout = 0;
		memset(vflags, 0, sizeof(vflags));
		vflags[s] = 1;

		while(qin != qout) {
			cv = q[qout++];
			for(x = 0; x < v; x++) {
				if(!vflags[x] && ecap[cv][x] - eflow[cv][x]) {
					q[qin++] = x;
					df_pi[x] = cv;
					vflags[x] = 1;
				}
			}
		}

		// have flow increase ?
		if(!vflags[d]) break;

		// compute max increase, do it
		mf = 0x7fff;
		for(x = d; x != s; x = df_pi[x]) {
			cf = ecap[df_pi[x]][x] - eflow[df_pi[x]][x];
			if(mf > cf) mf = cf;
		}
		for(x = d; x != s; x = df_pi[x]) {
			eflow[df_pi[x]][x] += mf;
			eflow[x][df_pi[x]] -= mf;
		}
	}
}

int far gid[N_GUIDES][3];
int main() {
	FILE *fp;
	int n, k, x;
	int ts, td;
	int w;

	// load & build links
	fp = fopen("ghizi.in", "rt");
	fscanf(fp, "%d%d", &n, &k);
	for(x = 0; x < n; x++) {
		fscanf(fp, "%d%d", &ts, &td); ts++; td++;
		gid[x][0] = ts; gid[x][1] = td; gid[x][2] = ++ecap[ts][td];
	}
	fclose(fp);

	// complete system & do the magic
	ecap[0][1] = k;
	do_flow(102, 0, 101);

	// score
	fp = fopen("ghizi.out", "wt");
	w = 0;
	for(x = 0; x < n; x++) {
		if(eflow[gid[x][0]][gid[x][1]] >= gid[x][2])
			w++;
	}
	fprintf(fp, "%d\n", w);
	for(x = 0; x < n; x++) {
		if(eflow[gid[x][0]][gid[x][1]] >= gid[x][2])
			fprintf(fp, "%d ", x + 1);
	}
	fprintf(fp, "\n");
	fclose(fp);

	return 0;
}