#include <string.h>
#include <stdio.h>
#include <stdlib.h>


#define N_MAX	501
#define BASE	10

#define IN_NAME "sala.in"
#define OUT_NAME "sala.out"


int A[N_MAX + 1];


void read_data(void)
{
    FILE *in_file = fopen(IN_NAME, "rt");
    int i;

    fscanf(in_file, "%d\n", A + 0);
    for (i = A[0]; i >= 1; i--)
	fscanf(in_file, "%d", A + i);
    fclose(in_file);
}


int remainder(int *A, int X)
{
    int i, R = 0;

    for (i = A[0]; i >= 1; i--)
	R = (BASE * R + A[i]) % X;
    return R;
}

void attrib(int *A, int X)
{
    for (A[0] = 0; X; X /= BASE)
	A[++A[0]] = X % BASE;
}

void add(int *A, int *B)
{
    int i, T = 0;

    if (A[0] < B[0]) {
	for (i = A[0] + 1; i <= B[0]; i++) A[i] = 0;
	A[0] = B[0];
    } else {
	for (i = B[0] + 1; i <= A[0]; i++) B[i] = 0;
    }
    for (i = 1; i <= A[0]; i++) {
	A[i] = A[i] + B[i] + T;
	T = A[i] / BASE;
	A[i] %= BASE;
    }
    if (T) A[++A[0]] = T;
}



void mul(int *A, int *B)
{
    int i, j, T = 0, C[N_MAX];
    
    memset(C, 0, sizeof(C));
    for (C[0] = A[0] + B[0] - 1, i = 1; i <= A[0]; i++)
	for (j = 1; j <= B[0]; j++)
	    C[i + j - 1] += A[i] * B[j];
    for (i = 1; i <= C[0]; i++) {
	C[i] = C[i] + T;
	T = C[i] / BASE;
	C[i] %= BASE;
    }
    if (T) C[++C[0]] = T;
    memcpy(A, C, sizeof(C));
}


void divide(int *A, int X)
{
    int i, R = 0;

    for (i = A[0]; i >= 1; i--) {
	A[i] = BASE * R + A[i];
	R = A[i] % X;
	A[i] /= X;
    }
    while (!A[A[0]] && A[0]) A[0]--;
}


void subtract(int *A, int *B)
{
    int i;

    for (i = B[0] + 1; i <= A[0]; i++) B[0] = 0;
    for (i = 1; i <= A[0]; i++) {
	A[i] = A[i] - B[i];
	if (A[i] < 0) {
	    A[i] += BASE;
	    A[i + 1] -= 1;
	}
    }
    while (!A[A[0]] && A[0]) A[0]--;
}


void write_solution(int *ary)
{
    FILE *out_file = fopen(OUT_NAME, "wt");
    int i;

    for (i = ary[0]; i >= 1; i--)
	fprintf(out_file, "%d", ary[i]);
    fprintf(out_file, "\n");

    fclose(out_file);
}


void solve(void)
{
    int _one[N_MAX], B[N_MAX], C[N_MAX];

    attrib(_one, 1);
    memcpy(B, A, sizeof(A));
    add(B, _one);
    mul(B, A);
    divide(B, 2);
    memcpy(C, B, sizeof(B));
    divide(C, 3);
    subtract(B, C);
    
    write_solution(B);
}


int main(void)
{
    read_data();
    solve();

    return EXIT_SUCCESS;
}
