#include <stdio.h>
#include <string.h>

#define max(a,b) ((a) > (b) ? (a) : (b))

typedef int bigint[512];

int nc;
bigint N;
bigint N3;
bigint temp;
bigint answer;

int divide(bigint x)
{
	int i, t, nx;

	t = 0;
	for (i = x[0]; i >= 1; i--)
	{
		nx = (x[i] + 10 * t) / 3;
		t = (x[i] + 10 * t) % 3;
		x[i] = nx;
	}
	while (!x[x[0]] && x[0] > 0) x[0]--;
	return t;
}

void add(bigint x, bigint y)
{
	int i, t;
	
	t = 0;
	x[0] = max(x[0], y[0]);
	for (i = 1; i <= x[0]; i++)
	{
		x[i] += y[i] + t;
		t = x[i] / 10;
		x[i] %= 10;
	}
	if (t)
		x[++x[0]] = t;
}

void mult(bigint r, bigint a, bigint b)
{
	int i, j, t;

	memset(r, 0, sizeof(r));
	r[0] = a[0] + b[0] - 1;
	for (i = 1; i <= a[0]; i++)
		for (j = 1; j <= b[0]; j++)
			r[i + j - 1] += a[i] * b[j];
	t = 0;
	for (i = 1; i <= r[0]; i++)
	{
		r[i] += t;
		t = r[i] / 10;
		r[i] %= 10;
	}
	while (t)
	{
		r[++r[0]] = t % 10;
		t /= 10;
	}
}

int main(void)
{
	FILE *fp;
	int rest, i;
	
	fp = fopen("sala.in", "r");
	memset(N, 0, sizeof(N));
	fscanf(fp, "%d", &N[0]);
	for (i = 0; i < N[0]; i++)
		fscanf(fp, "%d", &N[N[0] - i]);
	fclose(fp);

	memcpy(N3, N, sizeof(N3));
	rest = divide(N3);

	mult(answer, N, N3);
	for (i = 0; i <= rest; i++)
		add(answer, N3);
	memset(temp, 0, sizeof(temp));
	temp[0] = 1;
	temp[1] = rest;
	add(answer, temp);

	fp = fopen("sala.out", "w");
	for (i = answer[0]; i >= 1; i--)
		fprintf(fp, "%d", answer[i]);
	fprintf(fp, "\n");
	fclose(fp);

	return 0;
}
