#include <stdio.h>
#include <string.h>

struct big
{
	int cnt;
	int num[256];
};

#define base 10000

void clear(big &a)
{
	a.cnt = 0; memset(a.num, 0, sizeof(a.num));
}

void mul(big &a, long x)
{
	long t = 0; int i;
	for(i = 0; i < a.cnt; i ++)
	{
		t += x * a.num[i];
		a.num[i] = (int)(t % base);
		t /= base;
	}
	while(t)
	{
		a.num[i ++] = (int)(t % base);
		t /= base;
	}
	a.cnt = i;
}

void add(big &a, long x)
{
	long t = x; int i;
	for(i = 0; i < a.cnt; i ++)
	{
		t += a.num[i];
		a.num[i] = (int)(t % base);
		t /= base;
	}
	while(t)
	{
		a.num[i ++] = (int)(t % base);
		t /= base;
	}
	a.cnt = i;
}

void div3(big &a, big &b)
{
	int i, t = 0;
	b.cnt = a.cnt;

	if(a.num[a.cnt - 1] < 3)
		b.cnt --;

	for(i = a.cnt - 1; i >= 0; i --)
	{
		t *= base; t += a.num[i];
		if(i < b.cnt)
			b.num[i] = t / 3;
		t %= 3;
	}
}

void mul(big &a, big &b, big &c)
{
	clear(c); int i;
	for(i = 0; i < a.cnt; i ++)
	{
		long tmp = 0; int j;
		for(j = 0; j < b.cnt; j ++)
		{
			tmp += (long)a.num[i] * b.num[j] + (long)c.num[i + j];
			c.num[i + j] = (int)(tmp % base);
			tmp /= base;
		}
		while(tmp)
		{
			tmp += (long)c.num[i + j];
			c.num[i + j] = (int)(tmp % base);
			tmp /= base; j ++;
		}
		if(i + j > c.cnt)
			c.cnt = i + j;
	}
}

big val, v1, v2;
int n, rest;

int main(void)
{
	freopen("sala.in", "rt", stdin);
	freopen("sala.out", "wt", stdout);

	clear(val);
	rest = 0; int i;

	scanf("%d", &n);
	for(i = 0; i < n; i ++)
	{
		int tmp;
		scanf("%d", &tmp);
		mul(val, 10);
		add(val, tmp);
		rest += tmp;
	}

	rest %= 3;
	div3(val, v1);
	add(val, rest + 1);
	mul(val, v1, v2);
	add(v2, rest);

	printf("%d", v2.num[v2.cnt - 1]);
	for(i = v2.cnt - 2; i >= 0; i --)
		printf("%04d", v2.num[i]);
	printf("\n");

	fclose(stdin);
	fclose(stdout);
	return 0;
}