#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define	MAXN		400
#define	MAXM		500000
#define	MAXC		32000
#define	MAXNIV	8
#define	SKIPP	4

struct LISTA
{
	int poz;
	struct LISTA *urm;
} *lc[MAXC+1];

struct COADA
{
	int px, py, dr;
	struct COADA *urm;
} *cd1, *cd2;

struct SKIP
{
	int px, py;
	struct SKIP *urm[MAXNIV];
} csk;

int n, m, np, mc[2];
int p1[MAXN][2], p2[MAXM][2];
int is[MAXM], ux[MAXM], dm[MAXM];

void rsort( int cc )
{
	int i, j;
	struct LISTA *p, *q;

	for( i = m-1 ; i >= 0 ; i-- )
	{
		j = p2[is[i]][cc];
		p = (struct LISTA*)malloc( sizeof( struct LISTA ) );
		p->poz = is[i];
		p->urm = lc[j];
		lc[j] = p;
	}
	for( i = j = 0 ; i <= mc[cc] ; i++ )
	{
		for( p = lc[i] ; p ; )
		{
			is[j++] = p->poz;

			q = p->urm;
			free( p );
			p = q;
		}
		lc[i] = NULL;
	}
}

int cauta_pct( int cx, int cy )
{
	int a, b, pm;

	a = 0;
	b = m-1;
	while( a < b )
	{
		pm = (a+b)>>1;
		if( cx > p2[is[pm]][0] )
			a = pm+1;
		else
			b = pm;
	}
	if( a >= m || cx != p2[is[a]][0] )
		return -1;
	b = ux[a]-1;
	while( a < b )
	{
		pm = (a+b)>>1;
		if( cy > p2[is[pm]][1] )
			a = pm+1;
		else
			b = pm;
	}
	if( a >= m || cy != p2[is[a]][1] )
		return -1;
	return a;
}

int cauta_skip( int px, int py )
{
	struct SKIP *p, *q, *upd[MAXNIV];
	int i, niv;

	for( i = MAXNIV-1, p = &csk ; i >= 0 ; i-- )
	{
		for( ; p->urm[i] && ( p->urm[i]->px < px || ( p->urm[i]->px == px && p->urm[i]->py < py ) ) ; p = p->urm[i] );
		upd[i] = p;
	}

	if( p->urm[0]->px == px && p->urm[0]->py == py )
		return 1;
	q = (struct SKIP*)malloc( sizeof( struct SKIP ) );
	q->px = px;
	q->py = py;

	for( niv = 0 ; niv < MAXNIV-1 && (rand( )%SKIPP) ; niv++ );
	for( i = niv+1 ; i < MAXNIV ; i++ )
		q->urm[i] = NULL;
	for( i = 0 ; i <= niv ; i++ )
	{
		q->urm[i] = upd[i]->urm[i];
		upd[i]->urm[i] = q;
	}
	return 0;
}

void pune_coada( int px, int py, int dr )
{
	struct COADA *p;

	if( cauta_skip( px, py ) )
		return;

	p = (struct COADA*)malloc( sizeof( struct COADA ) );
	p->px = px;
	p->py = py;
	p->dr = dr;
	p->urm = NULL;
	cd2->urm = p;
	cd2 = p;
	if( !cd1 )
		cd1 = p;
}

int main( )
{
	int i;
	struct COADA *p;

	srand( time( NULL ) );
	freopen( "ajutor.in", "r", stdin );
	scanf( "%d%d", &n, &m );
	for( i = 0 ; i < n ; i++ )
		scanf( "%d%d", &p1[i][0], &p1[i][1] );
	for( i = 0 ; i < m ; i++ )
	{
		is[i] = i;
		dm[i] = -1;
		scanf( "%d%d", &p2[i][0], &p2[i][1] );
		if( p2[i][0] > mc[0] )
			mc[0] = p2[i][0];
		if( p2[i][1] > mc[1] )
			mc[1] = p2[i][1];
	}
	fclose( stdin );

	rsort( 1 );
	rsort( 0 );
	ux[m-1] = m;
	for( i = m-2 ; i >= 0 ; i-- )
		if( p2[is[i]][0] == p2[is[i+1]][0] )
			ux[i] = ux[i+1];
		else
			ux[i] = i+1;

	csk.px = csk.py = -1;
	for( i = 0 ; i < n ; i++ )
		pune_coada( p1[i][0], p1[i][1], 0 );

	for( np = 0 ; np < m && cd1 ; )
	{
		i = cauta_pct( cd1->px, cd1->py );
		if( i != -1 && dm[i] == -1 )
		{
			np++;
			dm[i] = cd1->dr;
		}

		if( cd1->px > 0 )
			pune_coada( cd1->px-1, cd1->py, cd1->dr+1 );
		if( cd1->py > 0 )
			pune_coada( cd1->px, cd1->py-1, cd1->dr+1 );
		if( cd1->px < mc[0] )
			pune_coada( cd1->px+1, cd1->py, cd1->dr+1 );
		if( cd1->py < mc[1] )
			pune_coada( cd1->px, cd1->py+1, cd1->dr+1 );

		p = cd1;
		cd1 = cd1->urm;
		free( p );
	}

	for( i = 0 ; i < m ; i++ )
		ux[is[i]] = dm[i];
	freopen( "ajutor.out", "w", stdout );
	for( i = 0 ; i < m ; i++ )
		printf( "%d\n", ux[i] );
	fclose( stdout );
	return 0;
}
