
	#include <stdio.h>

	#define MAXN  405
	#define MAXD	33000l
	#define TL	3300
	#define TN	MAXD/TL

	#ifdef __BORLANDC__
		#define BC

		#define intreg	long
	#else
		#ifdef BC
			#undef BC
		#endif

		#define intreg	int
	#endif

int dx[8]={-1, 0,   1, 1, 1, 0, -1, -1};
int dy[8]={-1, -1, -1, 0, 1, 1, 1, 0};

intreg M, sol, sx, sy, mark;
int n, found;

FILE *output;

	struct punct
		{
			intreg y, x;
		};

	struct elem
		{
			int info;
			elem *next;
		};

	struct bfelem
		{
			int x, y;

			bfelem *next;
		};

elem *G[TN][TN];
intreg viz[TN][TN];

bfelem *qa, *qb;
punct p[MAXN];

#define tx(x)  ((x)/TL)
#define ty(y)  ((y)/TL)

#define myabs(x)	( (x)>=0 ?	(x)	:	(-1)*(x)	)
#define dist(z)	(	myabs(p[(z)].x-sx) + myabs(p[(z)].y-sy) )

void tl_init()
{
	int i, j;

	for (i=0; i<TN; i++)
		for (j=0; j<TN; j++)
			{
				G[i][j]=NULL;
				viz[i][j]=0;
			}
}

void tl_add(int x, int y, int who)
{
	elem *e=new elem;

	if (!e)
		{
//			printf("nu am memorie!\n");
			return;
		}

	e->next=G[x][y];
	e->info=who;
	G[x][y]=e;
}

/*void bf_go(int x, int y)
{
	elem *e=G[x][y];
	while (e)
		{
			if ((sol<0)||(dist(e->info)<sol))
				{
					sol=dist(e->info);
					found=1;
				}
			e=e->next;
		}

	if (!found)
		{
			if (x>0) bf_go(x-1, y);
			if (y>0) bf_go(x, y-1);
			if (x<TN-1) bf_go(x+1, y);
			if (y<TN-1) bf_go(x, y+1);
		}
}*/

bfelem *bfecreate(int x, int y)
{
	bfelem *e=new bfelem;

	if (!e)
		{
//			printf("bf: nu mai am memorie\n");
			return NULL;
		}

	e->x=x;
	e->y=y;
	e->next=NULL;
	return e;
}

void bfpush(int x, int y)
{
	qb->next=bfecreate(x, y);
	qb=qb->next;
}

void bf_go()
{
	int justfound, i;
	bfelem *t;
	elem *e;

	qa=qb=bfecreate(int(tx(sx)), int(ty(sy)));
	viz[int(tx(sx))][int(ty(sy))]=mark;

	while (qa)
		{
			e=G[qa->x][qa->y];
			justfound=0;
			if (e)
				{
					if (!found) justfound=1;
					found=1;
				}
			while (e)
				{
					if ((sol<0)||(dist(e->info)<sol))
						{
							sol=dist(e->info);
						}
					e=e->next;
				}

//			found=0;
			if (!found||justfound)
				{
					for (i=0; i<8; i++)
						{
							if ((qa->y+dy[i]>=0)&&(qa->y+dy[i]<TN)&&(qa->x+dx[i]>=0)&&(qa->x+dx[i]<TN))
								if (viz[qa->x+dx[i]][qa->y+dy[i]]<mark)
									{
										viz[qa->x+dx[i]][qa->y+dy[i]]=mark;
										bfpush(qa->x+dx[i], qa->y+dy[i]);
									}
						}
				}

			t=qa;
			qa=qa->next;
			delete t;
		}
}

void m_solve()
{
	found=0;
	sol=-1;
	bf_go();
}

void m_write()
{
	#ifdef BC
		fprintf(output, "%ld\n", sol);
	#else
		fprintf(output, "%d\n", sol);
	#endif
}

void m_rsw()
{
	output=fopen("ajutor.out", "w");
	FILE *f=fopen("ajutor.in", "rt");

	#ifdef BC
		fscanf(f, "%ld%ld\n", &n, &M);
	#else
		fscanf(f, "%d%d\n", &n, &M);
	#endif

	int i;
	intreg j;

	for (i=0; i<n; i++)
		{
			#ifdef BC
				fscanf(f, "%ld%ld\n", &(p[i].x), &(p[i].y));
			#else
				fscanf(f, "%d%d\n", &(p[i].x), &(p[i].y));
			#endif

			tl_add(int(tx(p[i].x)), int(ty(p[i].y)), i);
		}

	for (j=0; j<M; j++)
		{
			#ifdef BC
				fscanf(f, "%ld%ld\n", &sx, &sy);
			#else
				fscanf(f, "%d%d\n", &sx, &sy);
			#endif

			mark=j+1;
			m_solve();
			m_write();
		}

	fclose(output);
	fclose(f);
}

int main(void)
{
	tl_init();

	m_rsw();

	return 0;
}
