#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

ifstream in("ajutor.in");
ofstream out("ajutor.out");

#define MAXN 500

struct point{int x,y;};

inline istream& operator>>(istream &is,point &p)
{is>>p.x>>p.y;return is;}
inline ostream& operator<<(ostream &os,const point &p)
{os<<p.x<<' '<<p.y;return os;}

inline int manhdist(const point &a,const point &b)
{return abs(a.x-b.x)+abs(a.y-b.y);}

int qcmppointa(const void *a,const void *b)
{return (((point*)a)->x+((point*)a)->y)-(((point*)b)->x+((point*)b)->y);}

int qcmppointb(const void *a,const void *b)
{return (((point*)a)->x-((point*)a)->y)-(((point*)b)->x-((point*)b)->y);}

int n,m;
point pa[MAXN],pb[MAXN];

void read()
{
	in>>n>>m;
	for (int i=0;i<n;i++) {in>>pa[i];pb[i]=pa[i];}
	qsort(pa,n,sizeof(point),qcmppointa);
	qsort(pb,n,sizeof(point),qcmppointb);
	/*for (int i=0;i<n;i++) out<<pa[i]<<'\n';out<<'\n';
	for (int i=0;i<n;i++) out<<pb[i]<<'\n';*/
}

inline int abs(int x){return x>0?x:-x;}

inline int slowsolve(const point &p)
{
	int rd=manhdist(pa[0],p);
	for (int i=1;i<n;i++)
	{
		int q=manhdist(pa[i],p);if (q<rd) rd=q;
	}
	return rd;
}

inline int fastsolve(const point &p)
{
	int rd=manhdist(pa[0],p);
	int a=0,b=n,med,q=p.x+p.y;
	while (a<b)
		{med=(a+b)/2;
		if (pa[med].x+pa[med].y<q) a=med+1;else	b=med-1;}
	do{q=manhdist(pa[b],p);if (q<rd) rd=q;b--;//out<<b<<' ';
	}while((pa[b].x>p.x||pa[b].y>p.y)&&b>=0);
	q=manhdist(pa[b],p);if (q<rd) rd=q;
	do{q=manhdist(pa[a],p);if (q<rd) rd=q;a++;//out<<a<<' ';
	}while((pa[a].x<p.x||pa[a].y<p.y)&&a<n);
	q=manhdist(pa[a],p);if (q<rd) rd=q;
	return rd;
	out<<'\n';
}

int main()
{
	point p;
	read();
	for (int i=0;i<m;i++)
	{
		in>>p;
		//if (slowsolve(p)!=fastsolve(p))	{out<<":(\n";return 1;}
		//out<<slowsolve(p)<<'\n';
		out<<fastsolve(p)<<'\n';
	}		
	return 0;
}

