#include <fstream.h>

ifstream in("ghizi.in");
ofstream out("ghizi.out");

#define MAXN 6000
#define MAXT 101

struct intnode
{
	int val;
	intnode* next;
	intnode(int vl,intnode* nxt){val=vl;next=nxt;}
};

int flow[MAXT][MAXT],n,k;
intnode* gi[MAXT][MAXT];

void read()
{
	int pa[MAXN],pb[MAXN];
	in>>n>>k;
	for (int i=0;i<n;i++)
		in>>pa[i]>>pb[i];
	for (int i=0;i<MAXT;i++)
		for (int j=0;j<MAXT;j++)
		{
			flow[i][j]=0;
			gi[i][j]=0;
		}
	for (int i=0;i<n;i++)
	{
		gi[pa[i]][pb[i]]=new intnode(i,gi[pa[i]][pb[i]]);
		flow[pa[i]][pb[i]]++;
	}
}

struct lifo
{int v[1000],sp,ep;
 lifo(){sp=ep=0;}
 inline int get(){int x=v[sp];sp++;return x;}
 inline void push(int x){v[ep++]=x;}
 inline bool isempty(){return sp>=ep;}
};

int path[MAXT],pathn;

bool getpath()
{
	lifo q;
	int prev[MAXT];
	for (int i=0;i<MAXT;i++) prev[i]=-1;
	q.push(0);
	prev[0]=0xFFFF;
	while (!q.isempty())
	{
		int c=q.get();
		//out<<"From "<<c<<" :\n";
		for (int i=0;i<MAXT;i++)
			if (flow[c][i]>0&&prev[i]<0)
			{
				if (i==MAXT-1) 
				{
					//out<<"Wooohooo got to "<<i<<'\n';out.flush();
					pathn=1;
					path[0]=MAXT-1;
					while (prev[c]!=0xFFFF)
					{
						path[pathn++]=c;
						c=prev[c];
					}
					path[pathn++]=0;
					return true;
				}
				q.push(i);
				//out<<"Got to "<<i<<'\n';
				prev[i]=c;
			}
	}
	return false;
}

template<class T>inline T min(T a,T b){return a>b?b:a;}
template<class T>inline T max(T a,T b){return a>b?a:b;}

void printflow()
{
	out<<"Flow:\n";
	for (int i=0;i<MAXT;i++)
		for (int j=0;j<MAXT;j++)
			if (flow[i][j]>0)
				out<<"From "<<i<<" to "<<j<<" flow= "<<flow[i][j]<<'\n';
}

void calcflow()
{
	bool ug[MAXN];
	int numg=0,flw=0;
	for (int i=0;i<n;i++)
		ug[i]=false;
	//printflow();
	for (flw=0;flw<k;)
	{
		if (!getpath())
		{
			out<<"Nu se poate.\n";
			return;
		}
		out.flush();
		int mf=0xFFFFFF;
		//for (int i=pathn-1;i>0;i--) out<<path[i]<<"->"<<path[i-1]<<' ';
		for (int i=pathn-1;i>0;i--)	mf=min(mf,flow[path[i]][path[i-1]]);
		//out<<"min flow="<<mf<<'\n';
		mf=min(mf,k-flw);
		for (int i=pathn-1;i>0;i--)
		{
			flow[path[i]][path[i-1]]-=mf;
			flow[path[i-1]][path[i]]+=mf;
		}
		flw+=mf;
	}
//	printflow();out<<"Wheeeee flow done.\n";
	for (int i=0;i<MAXT;i++)
		for (int j=0;j<i;j++)		
			while (flow[i][j]>0)
			{
				//out<<"From "<<i<<" to "<<j<<' ';
				if (!gi[j][i])
				{
					out<<"SOMETHING IS ROTTEN.\n";
					return;
				}
				ug[gi[j][i]->val]=true;
				numg++;
				//out<<" we have guide "<<gi[j][i]->val+1<<'\n';
				intnode* nd=gi[j][i];
				gi[j][i]=gi[j][i]->next;
				delete nd;
				flow[i][j]--;
			}
	out<<numg<<'\n';
	int qqq;
	for (qqq=0;qqq<n;qqq++)
		if (ug[qqq])
			{out<<qqq+1;break;}
	for (qqq++;qqq<n;qqq++)
		if (ug[qqq])
			out<<' '<<qqq+1;
	out<<'\n';
}

int main()
{
	read();
	calcflow();
	return 0;
}
