#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

ifstream in("sala.in");
ofstream out("sala.out");

#define MAXC 200

struct vlint
{
	char v[MAXC];
	inline char& operator[](int i){return v[i];}
	inline const char& operator[](int i)const{return v[i];}
	vlint(){};
	vlint(int x){for (int i=0;i<MAXC;i++) {v[i]=x%10;x=x/10;}}
	void divmod(int x,int&modres);
	void mul10();
};

void vlint::mul10()
{
	for (int i=MAXC-1;i>0;i--)
		v[i]=v[i-1];
	v[0]=0;
}

ostream& operator<<(ostream &os,const vlint &v)
{
	int i;
	for (i=MAXC-1;v[i]==0&&i>0;i--);
	for (;i>=0;i--) os<<(int)v[i];
	return os;
}

void operator+=(vlint &v,int x)
{
	int t=x;
	for (int i=0;i<MAXC;i++)
	{
		t+=v[i];
		v[i]=t%10;
		t/=10;
	}
	if (t) out<<"Add Overflow.\n";
}

void operator+=(vlint &a,const vlint &b)
{
	int t=0;
	for (int i=0;i<MAXC;i++)
	{
		t+=a[i]+b[i];
		a[i]=t%10;
		t/=10;
	}
	if (t) out<<"Add Overflow.\n";
}

vlint operator+(const vlint &a,int b)
{vlint r=a;r+=b;return r;}
vlint operator+(const vlint &a,const vlint&b)
{vlint r=a;r+=b;return r;}

vlint operator*(const vlint &v,int x)
{
	int t=0;
	vlint res;
	for (int i=0;i<MAXC;i++)
	{
		t+=v[i]*x;
		res[i]=t%10;
		t=t/10;
	}
	if (t) out<<"Mul Overflow.\n";
	return res;
}

vlint operator*(vlint a,const vlint &b)
{
	vlint res=0;
	for (int i=0;i<MAXC;i++)
	{
		res+=a*b[i];
		a.mul10();
	}
	return res;
}

void vlint::divmod(int x,int& modres)
{
	int t=0;
	for (int i=MAXC-1;i>=0;i--)
	{
		t=10*t+v[i];
		v[i]=t/x;
		t=t%x;
	}
	modres=t;
}

int slowsolve(int n,int q=2)
{		
	int s=0;
	bool qst[10000];
	for (int i=0;i<n;i++) qst[i]=(i%3!=q);
	//r (int i=0;i<n;i++) out<<(qst[i]?'B':'F');out<<'\n';
	for (int i=1;i<n;i++)
	{
		for (int j=0;j<n-i;j++)
		{
			if (qst[j]) s++;
			qst[j]=(qst[j]!=qst[j+1]);
		}
		if (qst[n-i]) s++;
	}
	if (qst[0]) s++;
	return s;
}

int smallsolve(int n)
{
	int m=n/3,r;
	r=4*m+3*m*(m-1);
	if (n%3==1)	r+=2*m+1;
	if (n%3==2)	r+=4*m+2;
	return r;
}

vlint coolsolve(vlint n)
{
	vlint res;
	int r;
	n.divmod(3,r);
	res=n*(3*n+1);
	if (r==1) res+=2*n+1;
	if (r==2) res+=4*n+2;
	return res;
}

istream& operator>>(istream &is,vlint &v)
{
	int n,q;
	is>>n;
	v=0;
	for (int i=n-1;i>=0;i--)
	{
		is>>q;
		v[i]=q;
	}
	return is;
}

int main()
{
	vlint n;in>>n;out<<coolsolve(n)<<'\n';
	/*for (int n=1;n<10000;n++)
	{
		out<<"n="<<n<<' ';
		out<<' '<<smallsolve(n)<<' '<<coolsolve(n)<<'\n';
	}*/
	return 0;
}

