#include <stdio.h>

#define RADIX 10
#define LEN 666

int N[LEN], aux[LEN], one[LEN], two[LEN], mod;

void subtract(int *a, int *b)
{
    int i, j = 0, borrow = 0;

    if (a[0] < b[0]) a[0] = b[0];
    for (i = 1; i <= a[0]; i++)
    {
        a[i] -= b[i] + borrow;
        if (a[i] < 0)
           borrow = 1, a[i] += RADIX;
        else
           borrow = 0;
        if (a[i] && i > j) j = i;
    }
    a[0] = j;
}

int divide(int *a, int b)
{
    int i, j = 0, rem = 0;

    for (i = a[0]; i; i--)
    {
        rem = rem * RADIX + a[i];
        a[i] = rem / b;
        rem %= b;
        if (a[i] && i > j) j = i;
    }
    a[0] = j;
    return rem;
}

void add(int *a, int *b)
{
    int i, carry = 0;
    
    if (a[0] < b[0]) a[0] = b[0];
    for (i = 1; i <= a[0]; i++)
    {
        a[i] += b[i] + carry;
        carry = a[i] / RADIX;
        a[i] %= RADIX;
    }
    if (carry) a[++a[0]] = carry;
}

void multiply(int *a, int b)
{
    int i, carry = 0;

    for (i = 1; i <= a[0]; i++)
    {
        a[i] = a[i] * b + carry;
        carry = a[i] / RADIX;
        a[i] %= RADIX;
    }
    while (carry)
          a[++a[0]] = carry % RADIX,
          carry /= RADIX;
}

void multiply(int *a, int *b)
{
    int i, j;
    
    for (i = 1; i < LEN; i++)
        aux[i] = 0;
    for (i = 1; i <= a[0]; i++)
    for (j = 1; j <= b[0]; j++)
        aux[i + j - 1] += a[i] * b[j];

    aux[0] = a[0] + b[0];
    multiply(aux, 1);
    if (!aux[aux[0]]) aux[0]--;
}

int main()
{
    FILE *f;
    int i, j;

    f = fopen("sala.in", "r");
    fscanf(f, "%d\n", &N[0]);
    for (i = 0; i < N[0]; i++)
        fscanf(f, "%d", &N[N[0] - i]);
    fclose(f);

    one[0] = 1; one[1] = 1;
    two[0] = 1; two[1] = 2;

    // c = (N - 1) / 3 ; r = (N - 1) % 3
    subtract(N, one); mod = divide(N, 3);
    // 3 * c ^ 2 + c
    multiply(N, N);  multiply(aux, 3); add(aux, N);
    // 2 * c + 1
    if (mod >= 0) add(aux, N), add(aux, N), add(aux, one);
    // 2 * c + 1
    if (mod >= 1) add(aux, N), add(aux, N), add(aux, one);
    // 2 * c + 2
    if (mod >= 2) add(aux, N), add(aux, N), add(aux, two);

    f = fopen("sala.out", "w");
    for (i = aux[0]; i; i--)
        fprintf(f, "%d", aux[i]);
    fprintf(f, "\n");
    fclose(f);

    return 0;
}

