#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#define input "ajutor.in"
#define output "ajutor.out"
#define INF 9999999

typedef struct t_punct
		{
			int x, y;
		} punct;

void readdata(void);
int comparex (const void *k1, const void *k2);
int compare (const void *k1, const void *k2);
int search(int li, int ls);

int n, px, mij, poz, p, py, s, ind = 0;
unsigned int len[500000], xsort[512], l[512];
long m;
char z[32001];
punct help[512], ac[500000];

int main(void)
{
	int i, j, p, nr, min;
	FILE *f;

	memset(help, 0, sizeof(help));
	memset(ac, 0, sizeof(ac));
	memset(l, 0, sizeof(l));
	memset(z, 0, sizeof(z));

	readdata();

	qsort(xsort, n, sizeof(int), comparex);
	qsort(l, ind, sizeof(int), compare);

	for (i = 0; i < m; i++)
	{
		min = INF;
		py = ac[i].y;
		for (j = 0; j < ind; j++)
		{
			px = l[j];
			if (abs(ac[i].x - px) > min)
				break;
			p = search(0, m - 1);
			if (p != -1)
				nr = abs(ac[i].x - help[p].x) + abs(ac[i].y - help[p].y);
			if (nr < min)
				min = nr;
		}
		len[i] = min;
	}

	f = fopen(output, "w");

	for (i = 0; i < m; i++)
		fprintf(f, "%d\n", len[i]);

	fclose(f);

	return 0;
}

void readdata(void)
{
	long i;
	FILE *f;

	f = fopen(input, "r");

	fscanf(f, "%d %d", &n, &m);

	for (i = 0; i < n; i++)
	{
		fscanf(f, "%d %d", &help[i].x, &help[i].y);
		xsort[i] = i;
		if (!z[help[i].x])
		{
			z[help[i].x] = 1;
			l[ind++] = help[i].x;
		}
	}

	for (i = 0; i < m; i++)
		fscanf(f, "%d %d", &ac[i].x, &ac[i].y);

	fclose(f);
}

int comparex (const void *k1, const void *k2)
{
	int *a1 = (int *) k1, *a2 = (int *) k2;

	if (help[*a1].x == help[*a2].x)
		return help[*a1].y - help[*a2].y;

	return help[*a1].x - help[*a2].x;
}

int compare (const void *k1, const void *k2)
{
	int *a1 = (int *) k1, *a2 = (int *) k2;

	return (*a1) - (*a2);
}

int search(int li, int ls)
{
	if (li > ls)
		return -1;
	mij = (li + ls) / 2;
	poz = xsort[mij];

	if (help[poz].x > px)
		return search(li, mij - 1);
	if (help[poz].x < px)
		return search(mij + 1, ls);
	if (help[poz].y > py)
	{
		s = search(li, mij - 1);
		if (s != -1)
			return s;
	}
	if (help[poz].y < py)
	{
		s = search(mij + 1, ls);
		if (s != -1)
			return s;
	}

	return poz;
}