/**/
#include <iostream.h>
#include <fstream.h>
#include <math.h>

ifstream in("munte.in");
ofstream out("munte.out");

#define MAXN 110
#define MAXK 40
typedef double real;

struct point
{
    real x,y;
};

istream& operator>>(istream &is,point &p)
{
    in>>p.x>>p.y;
    return is;
}

inline real sldif(const point &a,const point &b)
{
    return (b.y-a.y)/(b.x-a.x);
}

template<class T>inline T sqr(const T x){return x*x;}

inline real dist(const point &a,const point &b)
{
    return sqrt(sqr(a.y-b.y)+sqr(a.x-b.x));
}

point p[MAXN];
real mc[MAXN][MAXK];
int n,k,prev[MAXN][MAXK];
real l;

void read()
{
    in>>n>>k>>l;
    for (int i=0;i<n;i++)
        in>>p[i];
}

void printsol()
{
    int i=n-1,q=k,sol[MAXN],soln=0;
    out<<round(mc[i][q])<<'\n';
    sol[soln++]=i;
    while(prev[i][q]!=99999)
    {
        i=prev[i][q];
        q--;
        sol[soln++]=i;
    }
    for (i=soln-1;i>=0;i--)
        out<<sol[i]+1<<' ';
}

void solve()
{
    real mm,d,m;
    for (int i=0;i<n;i++)
        for (int j=0;j<=k;j++)
        {
            prev[i][j]=-1;
            mc[i][j]=1000.0;
        }
    prev[0][1]=99999;
    mc[0][1]=0;
    for (int i=0;i+1<n;i++)
    {
        //out<<"Trying from "<<i<<'\n';
        mm=sldif(p[i],p[i+1])-1;
        for (int j=i+1;j<n;j++)
        {
            m=sldif(p[i],p[j]);
            if (mm>=m)
            {
                //out<<"Jump over "<<j<<",it's too low\n";
                continue;
            }
            mm=m;
            d=dist(p[i],p[j]);
            if (d<=l)
                for (int q=0;q<=k;q++)
                    if (prev[i][q]>=0&&mc[j][q+1]>mc[i][q]+d)
                    {
                        //out<<i<<','<<q<<" -> "<<j<<','<<q+1<<'\n';
                        mc[j][q+1]=mc[i][q]+d;
                        prev[j][q+1]=i;
                    }
                    //else;else out<<j<<" is too far away\n";
        }
    }    
}

void dump()
{
    for (int i=0;i<n;i++)
    {
        for (int j=0;j<=k;j++)
            if (prev[i][j]>=0)
                out<<"with "<<j<<" from "<<prev[i][j]<<" len="<<mc[i][j];
        out<<'\n';
    }
    out<<"May the force be with you\n";
}

int main()
{
    read();
    solve();
    printsol();
    return 0;
}

