#include <fstream.h>
#include <iostream.h>
#include <stdlib.h>
#include <limits.h>

ifstream in("muzeu.in");
ofstream out("muzeu.out");

#define MAXN 60
#define MAXM 60
#define MAXC 11

int n,m,rm[MAXN][MAXM],cost[MAXC];

void read()
{
    in>>n>>m;
    for (int i=0;i<n;i++)
        for (int j=0;j<m;j++)
            in>>rm[i][j];
    cost[0]=0;
    for (int i=1;i<=10;i++)
        in>>cost[i];
}

bool st[MAXC],mat[MAXN][MAXM];
char prev[MAXN][MAXM];

void calcmat()
{
    for (int i=0;i<n;i++)
        for (int j=0;j<m;j++)
        {
            mat[i][j]=st[rm[i][j]];
            prev[i][j]='O';
        }
}

void dump()
{
    for (int i=0;i<MAXC;i++)
        out<<(st[i]?'Y':'N');
    out<<'\n';
    for (int i=0;i<n;i++)
    {
        for (int j=0;j<m;j++)
            out<<(mat[i][j]?'.':'@');
        out<<'\n';
    }
}

void dumpprev()
{
    for (int i=0;i<MAXC;i++)
        out<<(st[i]?'Y':'N');
    out<<'\n';
    for (int i=0;i<n;i++)
    {
        for (int j=0;j<m;j++)
            out<<prev[i][j];
        out<<'\n';
    }
}

int bestsum=0xFFFFFFF,psn;
char pathstring[MAXN*MAXM];

void getpathstring(bool force)
{
    int i=n-1,j=m-1;
    char ps[MAXN*MAXM],cpsn=0;
    while (i||j)
    {
        ps[cpsn++]=prev[i][j];
        if (prev[i][j]=='N') i++;else
        if (prev[i][j]=='S') i--;else
        if (prev[i][j]=='W') j++;else
        if (prev[i][j]=='E') j--;
//            out<<"All your base are belong to us.\n";
    }
    ps[cpsn]=0;
    if (cpsn<psn||force)
    {
        psn=cpsn;
        for (i=0;i<=psn;i++)
            pathstring[i]=ps[psn-i-1];
    }
    pathstring[psn]=0;
}

void calcpath(int qsm)
{
    int tail[MAXN*MAXM],tn=1,tp=0;
    tail[0]=0;
    mat[0][0]=false;
    while (tp<tn)
    {
        int i=tail[tp]>>8,j=tail[tp]&0xFF;
        tp++;
        if (i==n-1&&j==m-1)
        {
            //out<<"We've got a winner.\n";dumpprev();
            getpathstring(bestsum>qsm);
            bestsum=qsm;
/*            out<<"bestsum="<<bestsum<<'\n';
            out<<"psn="<<psn<<'\n';
            out<<"path="<<pathstring<<'\n';*/
        }
        if (i&&mat[i-1][j])
        {
            tail[tn++]=(((i-1)<<8)+j);
            mat[i-1][j]=false;
            prev[i-1][j]='N';
        }
        if (j&&mat[i][j-1])
        {
            tail[tn++]=((i<<8)+j-1);
            mat[i][j-1]=false;
            prev[i][j-1]='W';
        }
        if (i+1<n&&mat[i+1][j])
        {
            tail[tn++]=(((i+1)<<8)+j);
            mat[i+1][j]=false;
            prev[i+1][j]='S';
        }
        if (j+1<m&&mat[i][j+1])
        {
            tail[tn++]=((i<<8)+j+1);
            mat[i][j+1]=false;
            prev[i][j+1]='E';
        }
    }
}

void back(int lev,int qsm)
{
    if (qsm>bestsum) return;
    if (lev==MAXC)
    {
        calcmat();
        //dump();
        calcpath(qsm);
        return;
    }
    st[lev]=true;
    back(lev+1,qsm+cost[lev]);
    st[lev]=false;
    back(lev+1,qsm);
}

int main()
{
    read();
    st[0]=true;
    back(1,0);
    out<<bestsum<<'\n'<<psn<<'\n'<<pathstring<<'\n';
    return 0;
}

