#include <fstream.h>
#include <time.h>

ifstream in("scufita.in");
ofstream out("scufita.out");

#define MAXN 15
#define MAXLAPS 15

int scuf[MAXN][MAXN],lup[MAXN][MAXN],n,lupciup[MAXLAPS];
int vc[4][2]={{1,0},{0,1},{-1,0},{0,-1}};
int bestscore=0;
char psvc[5]="SENV";
char bestpath[MAXLAPS+1];
char path[MAXLAPS+1];

int glbtmv=0;

inline bool timeover()
{
    glbtmv++;
    if (glbtmv%1000==0)
        if (clock()>=0.9*CLOCKS_PER_SEC)
            return true;
    return false;
}

bool back(int x,int y,int lev,int score)
{
    if (lev==MAXLAPS)
    {
        if (score>bestscore)
        {
            for (int i=0;i<=MAXLAPS;i++)
                bestpath[i]=path[i];
            bestscore=score;
        }
        return true;
    }
    if (score<=lupciup[lev])
        return true;
    for (int q=0;q<4;q++)
        if (scuf[x+vc[q][0]][y+vc[q][1]])
        {
            int tmp=scuf[x+vc[q][0]][y+vc[q][1]];
            scuf[x+vc[q][0]][y+vc[q][1]]=0;
            path[lev]=psvc[q];
            if (!back(x+vc[q][0],y+vc[q][1],lev+1,score+tmp))
                return false;
            scuf[x+vc[q][0]][y+vc[q][1]]=tmp;
            if (timeover()) return false;
        }
    return true;
}

void read()
{
    in>>n;
    int i,j;
    for (i=0;i<MAXN;i++)
        for (j=0;j<MAXN;j++)
            scuf[i][j]=lup[i][j]=0;
    for (i=1;i<=n;i++)
        for (j=1;j<=n;j++)
            in>>scuf[i][j];
    for (i=1;i<=n;i++)
        for (j=1;j<=n;j++)
            in>>lup[i][j];
}

void calclup()
{
    int i=1,j=1,ciupi,q=0,b;
    ciupi=lup[1][1];
    lup[1][1]=0;
    lupciup[0]=-100;
    for (q=1;q<=MAXLAPS;q++)    
    {
        b=0;
        for (int nb=1;nb<4;nb++)
            if (lup[i+vc[nb][0]][j+vc[nb][1]]>lup[i+vc[b][0]][j+vc[b][1]])
                b=nb;
        i+=vc[b][0];
        j+=vc[b][1];
        ciupi+=lup[i][j];
        lup[i][j]=0;
        lupciup[q]=ciupi;
    }
    //for (q=0;q<MAXLAPS;q++) out<<lupciup[q]<<' ';
}

int main()
{
    read();
    calclup();
    path[MAXLAPS]=0;
    int qqq=scuf[1][1];
    scuf[1][1]=0;
    back(1,1,0,qqq);
    if (bestscore==0)
        out<<"It's not working dude.\n";
    out<<bestscore<<'\n'<<bestpath<<'\n';
    return 0;
}

