#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int n;
float S;
int m;
float *coord[3];
FILE *file;

void Init(void);
void Free(void);
void Solve(void);

void _makecoord(float x1, float y1, float x2, float y2);
void _clearcoord(void);
void _qsort(int ll, int rl, int idx);

int main(void)
{
 Init();
 Solve();
 Free();
 return 0;
}

void Init(void)
{
 int i;
 float x1,y1,x2,y2;
 file=fopen("inter.in","r");
 fscanf(file,"%d\n",&n);
 for (i=0;i<3;i++)
  coord[i]=malloc(sizeof(float)*n*2);
 for (i=0;i<n;i++)
 {
  fscanf(file,"%f %f %f %f",&x1,&y1,&x2,&y2);
  _makecoord(x1,y1,x2,y2);
 }
 fclose(file);
 file=fopen("inter.out","w");
}

void Free(void)
{
 int i;
 fclose(file);
 for (i=0;i<3;i++)
  free(coord[i]);
}

void Solve(void)
{
 int i;
 int idx1,idx2;
 _clearcoord();
 _qsort(0,m-1,2);
 idx1=0;
 while ((coord[2][idx1]==0)&&(idx1<m))
  idx1++;
 if (idx1==m)
 {
  fprintf(file,"15.00\n");
  return;
 }
 _qsort(idx1,m-1,1);
 idx2=idx1;
 while ((coord[1][idx2]<0)&&(idx2<m))
  idx2++;
 _qsort(idx1,idx2-1,0);
 for (i=idx1;i<idx2-1;i++)
  S+=abs(coord[0][i+1]-coord[0][i])*(abs(coord[1][i])+abs(coord[1][i+1]))/2;
 _qsort(idx2,m-1,0);
 for (i=idx2;i<m-1;i++)
  S+=abs(coord[0][i+1]-coord[0][i])*(abs(coord[1][i])+abs(coord[1][i+1]))/2;
 fprintf(file,"%.2f",S);
}

void _makecoord(float x1, float y1, float x2, float y2)
{
 int ll[2],rl[2];
 int tl[2],bl[2];
 int i;
 ll[0]=ll[1]=rl[0]=rl[1]=1;
 tl[0]=tl[1]=bl[0]=bl[1]=1;
 for (i=0;i<m;i++)
 {
  if (coord[0][i]>x1)
   ll[0]=0;
  if (coord[0][i]>x2)
   ll[1]=0;
  if (coord[0][i]<x1)
   rl[0]=0;
  if (coord[0][i]<x2)
   rl[1]=0;
  if (coord[0][i]>y1)
   tl[0]=0;
  if (coord[0][i]>y2)
   tl[1]=0;
  if (coord[0][i]<y1)
   bl[0]=0;
  if (coord[0][i]<y2)
   bl[1]=0;
 }
 if (ll[0]||rl[0]||tl[0]||bl[0])
 {
  coord[0][m]=x1;
  coord[1][m]=y1;
  coord[2][m]=1;
  m++;
 }
 if (ll[1]||rl[1]||tl[1]||bl[1])
 {
  coord[0][m]=x2;
  coord[1][m]=y2;
  coord[1][m]=1;
  m++;
 }
}

void _clearcoord(void)
{
 int ll,rl,tl,bl;
 int i,j;
 for (i=0;i<m;i++)
 {
  ll=rl=tl=bl=0;
  for (j=0;j<m;j++)
  {
   if (i==j)
    continue;
   if (coord[0][i]>=coord[0][j])
    ll=1;
   if (coord[0][i]<=coord[0][j])
    rl=1;
   if (coord[1][i]>=coord[1][j])
    tl=1;
   if (coord[1][i]<=coord[1][j])
    bl=1;
  }
  if (ll&&rl&&tl&&bl)
   coord[2][i]=0;
 }
}

void _qsort(int ll, int rl, int idx)
{
 int i,j,i0,j0,c;
 float dc;
 if (ll<rl)
 {
  i=ll;
  j=rl;
  i0=1;
  j0=0;
  while (i<j)
  {
   if (coord[idx][i]>coord[idx][j])
   {
    dc=coord[0][i];
    coord[0][i]=coord[0][j];
    coord[0][j]=dc;
    dc=coord[1][i];
    coord[1][i]=coord[1][j];
    coord[1][j]=dc;
    dc=coord[2][i];
    coord[2][i]=coord[2][j];
    coord[2][j]=dc;
    c=i0;
    i0=-j0;
    j0=-c;
   }
   i+=i0;
   j+=j0;
  }
  _qsort(ll,i-1,idx);
  _qsort(i+1,rl,idx);
 }
}