#include <stdio.h>
#include <stdlib.h>

#define fi "inter.in"
#define fo "inter.out"

typedef struct pct_ {double x,y;} pct;
typedef struct dr_ {pct a,b;} dr;

int n;
long nrp=0,nrs;
dr *a;
pct *pr,*pr2;

void load()
{
FILE *f;
int i;
f=fopen(fi,"rw");
fscanf(f,"%d",&n);
a=(dr*)calloc(n,sizeof(dr));
pr=(pct*)calloc(n*(n-1)/2,sizeof(pct));
pr2=(pct*)calloc(n*(n-1)/2,sizeof(pct));
for(i=0;i<n;i++)
 fscanf(f,"%lf %lf %lf %lf",&a[i].a.x,&a[i].a.y,&a[i].b.x,&a[i].b.y);
fclose(f);
}

void dr_inter(dr a1,dr a2,double *xr, double *yr)
{
double m,m1,x,y;
if ( (a1.a.x!=a1.b.x) && (a2.a.x!=a2.b.x))
  {
    m=(a1.b.y-a1.a.y)/(a1.b.x-a1.a.x);
    m1=(a2.b.y-a2.a.y)/(a2.b.x-a2.a.x);
    if (m1!=m)
      {
       x=(m1*a2.a.x-a2.a.y-m*a1.a.x+a1.a.y) / (m1-m);
       y=m*x-m*a1.a.x+a1.a.y;
      }
  }
else
  {
    if (a1.a.x==a1.b.x)
       {
	x=a1.a.x;
	m1=(a2.b.y-a2.a.y)/(a2.b.x-a2.a.x);
	y=m1*x-m1*a2.a.x+a2.a.y;
       }
    else
     if (a2.a.x==a2.b.x)
       {
	x=a2.a.x;
	m1=(a1.b.y-a1.a.y)/(a1.b.x-a1.a.x);
	y=m1*x-m1*a1.a.x+a1.a.y;
       }
  }
*xr=x;
*yr=y;
}

double cross_prod(pct a, pct b, pct c)
{
return (a.x-c.x)*(b.y-c.y)-(a.y-c.y)*(b.x-c.x);
}

int fcp(const void *a, const void *b)
{
pct *aa=(pct*)a,*bb=(pct*)b;
if ((aa->y<bb->y) || ((aa->y==bb->y)&&(aa->x<bb->x)))
    return -1;
if ((aa->y>bb->y) || ((aa->y==bb->y)&&(aa->x>bb->x)))
    return 1;
return 0;
}

void go()
{
long i,j;
double x,y;
for(i=0;i<n-1;i++)
  for(j=i+1;j<n;j++)
    {
      dr_inter(a[i],a[j],&x,&y);
      pr[nrp].x=x;
      pr[nrp].y=y;
      nrp++;
    }
qsort(pr,nrp,sizeof(pct),fcp);
pr2[0]=pr[0];pr2[1]=pr[1];
nrs=1;
for (i=2;i<nrp;i++)
   if (cross_prod(pr[i],pr2[nrs],pr2[nrs-1])==0) pr2[nrs]=pr[i];
    else
      if (cross_prod(pr[i],pr2[nrs],pr2[nrs-1])>0) pr2[nrs]=pr[i];
    else
      pr2[++nrs]=pr[i];
}

double arie()
{
double ar;
long i;
ar=pr2[0].x*(pr2[nrs].y-pr2[1].y);
pr2[nrs+1]=pr2[0];
for(i=1;i<=nrs;i++)
  ar+=pr2[i].x*(pr2[i-1].y-pr2[i+1].y);
if (ar<0) ar=-ar;
return ar/2;
}

void save()
{
FILE *f;
f=fopen(fo,"wt");
fprintf(f,"%.2lf\n",arie());
fclose(f);
}

int main()
{
load();
go();
save();
return 0;
}