#include <fstream.h>
#include <math.h>

ifstream in("inter.in");
ofstream out("inter.out");

#define INF 1000000000

//!!!!!!!!!!!!!!!!
#define MAX 5005
#define MAXTARA 100000
#define MAXSTK 5005

int n;
struct pt
 {
  double x;
  double y;
 };

struct dr
 {
  pt a;
  pt b;
 };

pt P[MAX];
int np;
dr D[MAX];

int stk[MAXSTK];
long st,ed;

#define QPUSH(i) (stk[st++]=i)
#define QPOP() (ed--)

inline void QADD(int a)
 {
  stk[ed++]=a;
 }

pt Intersect(int i, int j)
 {
  double x1,x2,y1,y2;
  double a1,b1,a2,b2;
  int cs=0;
  int cy=0;
  double Xcs,Ycs;
  x1=D[i].a.x;x2=D[i].b.x;y1=D[i].a.y;y2=D[i].b.y;
  if(y1-y2) if(x1-x2) {a1=(x1-x2)/(y1-y2);b1=y1-a1*x1;}
	    else {cs=1;Xcs=x1;}
  else {Ycs=y1;cy=1;}
  x1=D[j].a.x;x2=D[j].b.x;y1=D[j].a.y;y2=D[j].b.y;
  if(y1-y2) if(x1-x2) {a2=(x1-x2)/(y1-y2);b2=y1-a2*x1;}
	    else {cs=2;Xcs=x1;}
  else {Ycs=y1;cy=2;}

  double x,y;

  if(cs)
   {
    if(cs==1)
     {
      x=Xcs;
      y=a2*x+b2;
     }
    else
     {
      x=Xcs;
      y=a1*x+b1;
     }
   }
  else if(cy)
   {
    if(cy==1)
     {
      y=Ycs;
      x=(y-b2)/a2;
     }
    else
     {
      y=Ycs;
      x=(y-b1)/a1;
     }
   }
  else
  if(a1!=0)
   {
    if(a2!=0)
     {
      y=(a1*b2-b1*a2)/(a1-a2);
      x=(y-b1)/a1;
     }
    else
     {
      y=b2;
      x=(y-b1)/a1;
     }
   }
  else
   {
    y=b1;
    x=(y-b2)/a2;
   }

  pt r;
  r.x=x;r.y=y;

  return r;
 }

pt Pt[MAXTARA];
double key[MAXTARA];
long O;
long K;

long hpl;

#define LEFT(i) (2*(i)+1)
#define RIGHT(i) (2*(i)+2)

void Heapify(long i)
 {
  long max=i;
  while(1)
   {
    if(LEFT(i)<hpl)
	if(key[LEFT(i)]>key[i]) max=LEFT(i);
    if(RIGHT(i)<hpl)
	if(key[RIGHT(i)]>key[max]) max=RIGHT(i);
    if(i==max) break;
    pt t;
    double tk;
    t=Pt[i];Pt[i]=Pt[max];Pt[max]=t;
    tk=key[i];key[i]=key[max];key[max]=tk;
    i=max;
   }
 }

void Sort()
 {
 long i;
  pt t=Pt[O];
  Pt[O]=Pt[0];
  Pt[0]=t;

  key[0]=0;

  for(i=0;i<K;i++)
    key[i]=(Pt[i].y-t.y)/(Pt[i].x-t.x);

  hpl=K;
  for(i=hpl/2;i>=0;i--)
	Heapify(i);
  while(hpl)
   {
   hpl--;
    double tk;
    t=Pt[0];Pt[0]=Pt[hpl];Pt[hpl]=t;
    tk=key[0];key[0]=key[hpl];key[hpl]=tk;
    Heapify(0);
   }
 }

int Orient(double x1, double y1, double x2, double y2, double x3, double y3)
 {
  double R=0;
  R=x2*y3+x3*y1+x1*y2-x2*y1-x1*y3-x3*y2;
  if(R<0) return -1;
  else if(R==0) return 0;
  else if(R>0) return 1;
  return 1;
 }

void CHullTaranie()
 {
  long i,j;
  pt r;
  r.x=INF;
  r.y=INF;
  K=0;
  for(i=0;i<n;i++)
   for(j=i+1;j<n;j++)
    {
     pt R=Intersect(i,j);
     if(R.y<r.y) {r=R;O=K;}
     else if(R.y==r.y && R.x<r.x) {r=R;O=K;}
     Pt[K++]=R;
    }
  Sort();//!
  st=ed=0;
  QPUSH(0);
  QPUSH(1);
  for(i=2;i<K;i++)
   {
    pt b=Pt[stk[ed-1]];
    pt a=Pt[stk[ed-2]];
    pt c=Pt[i];
    int is=0;
    while(Orient(a.x,a.y,b.x,b.y,c.x,c.y)<=0)
     {
      QPOP();
      b=Pt[stk[ed-1]];
      a=Pt[stk[ed-2]];
      is=1;
     }
    if(is) QPUSH(i);
   }
  np=ed;
  for(i=0;i<ed;i++) P[i]=Pt[stk[i]];
 }

void CHullSmen()
 {
 }

int main()
 {
  in>>n;
  int i;
  double a,b,c,d;
  for(i=0;i<n;i++)
   {
    in>>D[i].a.x>>D[i].a.y>>D[i].b.x>>D[i].b.y;
   }
  if(n<501) CHullTaranie();
  else CHullSmen();
  double S=0;
  P[np]=P[0];
  for(i=0;i<np;i++)
   {
    S+=P[i].x*P[i+1].y-P[i].y*P[i+1].x;
   }
  S/=2;
  long R=(long)S;
  out<<S<<".";
  R=(long)((S-R)*100);
  if(R<10) out<<0;
  out<<R;
  return 0;
 }
