{$I-,Q-,R-,S-}
const
  nmax = 5001; { 5001 }
  finame = 'inter.in';
  foname = 'inter.out';
  inf = 1e15;
var
  fi, fo: text;
  n, nn, m, mm: longint; aux, aria: extended;
  x1, y1, x2, y2, a, b, c, p: array[1..nmax] of extended; { extended }
  x, y: array[0..nmax * 2] of extended;
  u, s: array[0..nmax * 2] of byte; k: longint;

     function greater(i, j: longint): boolean;
     begin
       greater := (y[i] > y[j]) or ((y[i]=y[j]) and (x[i] > x[j]));
     end;

     procedure swap(i, j: longint);
     begin
       aux := x[i]; x[i] := x[j]; x[j] := aux;
       aux := y[i]; y[i] := y[j]; y[j] := aux;
     end;

     procedure sift(k: longint);
     var f: longint;
     begin
       repeat
         if 2*k <= m then
         begin
           f := 2*k;
           if f+1 <= m then
             if greater(f+1, f) then inc(f);
           if greater(k, f) then f := 0;
         end else f := 0;
         if f <> 0 then
           begin swap(k, f); k := f; end;
       until f=0;
     end;

     procedure sortdata;
     var i: longint;
     begin
       for i := m div 2 downto 1 do sift(i);
       mm := m;
       while m > 1 do
       begin
         swap(1, m);
         dec(m); sift(1);
       end;
       m := mm;
     end;

{ sortarea pentru drepte }

     function panta(i: longint): extended;
     begin
       if x1[i] = x2[i]
         then panta := inf
         else panta := (y1[i] - y2[i]) / (x1[i] - x2[i]);
     end;

     procedure swap_panta(i, j: longint);
     var aux: extended;
     begin
       aux := x1[i]; x1[i] := x1[j]; x1[j] := aux;
       aux := x2[i]; x2[i] := x2[j]; x2[j] := aux;
       aux := y1[i]; y1[i] := y1[j]; y1[j] := aux;
       aux := y2[i]; y2[i] := y2[j]; y2[j] := aux;
       aux :=  p[i];  p[i] :=  p[j];  p[j] := aux;
     end;

     procedure sift_panta(k: longint);
     var f: longint;
     begin
       repeat
         if 2*k <= n then
         begin
           f := 2*k;
           if f+1 <= n then
             if p[f+1] > p[f] then inc(f);
           if p[k] > p[f] then f := 0;
         end else f := 0;
         if f <> 0 then
           begin swap_panta(k, f); k := f; end;
       until f=0;
     end;

     procedure sort_panta;
     var i: longint;
     begin
       for i := 1 to n do p[i] := panta(i);
       for i := n div 2 downto 1 do sift_panta(i);
       nn := n;
       while n > 1 do
       begin
         swap_panta(1, n);
         dec(n); sift_panta(1);
       end;
       n := nn;
     end;


procedure readdata;
var i: longint;
begin
  assign(fi, finame);
  reset(fi);
  read(fi, n);
  for i := 1 to n do
    read(fi, x1[i], y1[i], x2[i], y2[i]);
  close(fi);
end;

procedure coiefici;
var i: longint;
begin
  for i := 1 to n do
  begin
    a[i] := y1[i] - y2[i];
    b[i] := x2[i] - x1[i];
    c[i] := x1[i] * y2[i] - x2[i] * y1[i];
  end;
end;

procedure initdata;
var i, j: longint;
begin
  m := 0;
  for i := 1 to n-1 do
  begin
    j := i+1;
    {
      avem sistemul:
        ai * x + bi * y + ci = 0
        aj * x + bj * y + cj = 0
    }
    inc(m);
    y[m] := (a[j] * c[i] - a[i] * c[j]) / (a[i] * b[j] - a[j] * b[i]);
    x[m] := (b[j] * c[i] - b[i] * c[j]) / (a[j] * b[i] - a[i] * b[j]);
  end;
  i := 1; j := n;
  inc(m);
  y[m] := (a[j] * c[i] - a[i] * c[j]) / (a[i] * b[j] - a[j] * b[i]);
  x[m] := (b[j] * c[i] - b[i] * c[j]) / (a[j] * b[i] - a[i] * b[j]);
end;

function semn(i, j, k: longint): longint;
var r: extended;
begin
  r := + (x[i] * y[j]) + (x[j] * y[k]) + (x[k] * y[i])
       - (y[i] * x[j]) - (y[j] * x[k]) - (y[k] * x[i]);

  if r > 0 then semn := +1
  else if r < 0 then semn := -1
  else semn := 0;
end;

procedure solvprob;
{ infasuratoare convexa }
var i: longint;
begin
  fillchar(u, sizeof(u), 0);
  k := 1;
  s[1] := 1; s[0] := 0;
  u[1] := 0; u[0] := 1;
  y[0] := y[1]; x[0] := x[1] - 1;

  for i := 2 to m do
    if u[i] = 0 then
    begin
      while k > 1 do
        if semn(i, s[k], s[k-1]) > 0 then
        begin
          u[s[k]] := 0;
          s[k] := 0;
          dec(k);
        end else break;
      inc(k);
      s[k] := i;
      u[i] := 1;
    end;

  for i := m-1 downto 1 do
    if u[i] = 0 then
    begin
      while k > 1 do
        if semn(i, s[k], s[k-1]) > 0 then
        begin
          u[s[k]] := 0;
          s[k] := 0;
          dec(k);
        end else break;
      inc(k);
      s[k] := i;
      u[i] := 1;
    end;
end;

procedure writesol;
var i: longint;
begin
  assign(fo, foname);
  rewrite(fo);
  aria := 0;
  for i := 1 to k-1 do
    aria := aria + x[ s[i] ] * y[ s[i+1] ] - x[ s[i+1] ] * y[ s[i] ];
  aria := abs(aria) / 2;
  writeln(fo, aria:0:2);
  close(fo);
end;

begin
  readdata;
  sort_panta;
  coiefici;
  initdata;
  sortdata;
  solvprob;
  writesol;
end.
