#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#define	MAXN		65536

long long n, k, p;
long long h[MAXN+1], ph[MAXN+1], a[MAXN];

void schimba_heap( long long a, long long b )
{
	long long t;

	ph[h[a]] = b;
	ph[h[b]] = a;
	t = h[a];
	h[a] = h[b];
	h[b] = t;
}

void urca_heap( long long pc )
{
	for( ; pc > 1 && a[h[pc]]*h[pc] > a[h[pc>>1]]*h[pc>>1] ; pc >>= 1 )
		schimba_heap( pc, pc>>1 );
}

void coboara_heap( long long pc )
{
	long long pp;

	while( 1 )
	{
		pp = (pc<<1);
		if( (pp|1) <= p && a[h[pp|1]]*h[pp|1] > a[h[pp]]*h[pp] )
			pp |= 1;
		if( pp > p || a[h[pc]]*h[pc] > a[h[pp]]*h[pp] )
			return;
		schimba_heap( pp, pc );
		pc = pp;
	}
}

long long calc_max( long long nr )
{
	long long i;

	memset( h, 0, sizeof( h ) );
	memset( ph, 0, sizeof( ph ) );
	memset( a, 0, sizeof( ph ) );
	a[1] = nr;
	for( i = 1 ; i <= p ; i++ )
	{
		h[i] = i;
		ph[i] = i;
	}

	for( i = 2 ; i <= p ; i++ )
		while( (a[i]+1)*i < a[h[1]]*h[1] )
		{
			a[h[1]]--;
			coboara_heap( 1 );
			a[i]++;
			urca_heap( ph[i] );
		}

	return a[h[1]]*h[1];
}

int main( )
{
	long long i, m1, m2;

	freopen( "proc.in", "r", stdin );
	scanf( "%lld%lld%lld", &n, &k, &p );
	fclose( stdin );

	m1 = calc_max( n );
	m2 = calc_max( n-k );

	freopen( "proc.out", "w", stdout );
	printf( "%lld", m1+m2 );
	fclose( stdout );
	return 0;
}
