#include <stdio.h>
#include <stdlib.h>

struct line
{
	double a, b, c;
};

struct point
{
	double x, y;
};

#define max 1000
#define max2 (max * (max - 1) / 2)

line l[max];
point p[max2];
double eps = 1e-12;
int n, m;

int tab[max2 + 1], usd[max2];
int count = 0;

inline void get_abc(double x1, double y1, double x2, double y2, double &a, double &b, double &c)
{
	a = y1 - y2;
	b = x2 - x1;
	c = y2*x1 - y1*x2;
}

inline int get_sign(double a, double b, double c, point p)
{
	double res = p.x*a + p.y*b + c;
	if(res < -eps) return -1;
	if(res > +eps) return +1;
	return 0;
}

inline int cmp_point(const void *a, const void *b)
{
	double resx = ((point*)a)->x - ((point*)b)->x;
	double resy = ((point*)a)->y - ((point*)b)->y;
	if(resx < -eps) return -1;
	if(resx > +eps) return +1;
	if(resy < -eps) return -1;
	if(resy > +eps) return +1;
	return 0;
}

void add_point(int i)
{
	tab[count ++] = i;
	usd[i] = 1;
	while(count > 2)
	{
		double a, b, c;
		get_abc(p[tab[count - 3]].x, p[tab[count - 3]].y, p[tab[count - 2]].x, p[tab[count - 2]].y, a, b, c);
		if(get_sign(a, b, c, p[i]) <= 0)
		{
			usd[tab[count - 2]] = 0;
			tab[count - 2] = i;
			count --;
		}
		else break;
	}
}

int main(void)
{
	freopen("inter.in", "rt", stdin);
	freopen("inter.out", "wr", stdout);

	scanf("%d", &n);
	if(n > max)
	{
	}


	int i;
	for(i = 0; i < n; i ++)
	{
		double x1, y1, x2, y2;
		scanf("%lf %lf %lf %lf", &x1, &y1, &x2, &y2);
		get_abc(x1, y1, x2, y2, l[i].a, l[i].b, l[i].c);
	}

	m = 0; int last = -1;
	for(i = 0; i < n; i ++)
		for(int j = 0; j < i; j ++)
		{
			double delta = l[i].a*l[j].b - l[j].a*l[i].b;
			double deltax = l[i].b*l[j].c - l[j].b*l[i].c;
			double deltay = l[i].c*l[j].a - l[j].c*l[i].a;

			p[m].x = deltax / delta;
			p[m].y = deltay / delta;
			m ++;
		}
	qsort(p, m, sizeof(point), cmp_point);

	for(i = 0; i < m; i ++)		// taiem punctele indentice
	{
		if(last == -1) last = i;
		else
		{
			if(cmp_point(&p[last], &p[i]) != 0)
			{
				last ++; p[last] = p[i];
			}
		}
	}
	m = last + 1;

	for(i = 0; i < m; i ++)
		usd[i] = 0;

	usd[0] = 0;
	for(i = 0; i < m; i ++)
		if(!usd[i])
			add_point(i);

	usd[0] = 0;
	for(i = m - 1; i >= 0; i --)
		if(!usd[i])
			add_point(i);

	double area = 0;
	for(i = 0; i < count - 1; i ++)
		area += p[tab[i]].x * p[tab[i + 1]].y;
	for(i = 1; i < count; i ++)
		area -= p[tab[i]].x * p[tab[i - 1]].y;
	if(area < 0) area = -area;
	area *= 0.5;

	printf("%.2lf\n", area);
	fclose(stdin);
	fclose(stdout);
	return 0;
}
