#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef struct {
	float x, y;
} point;
point a[10001];
int n, i, last, curr;
float minx, miny, S;
FILE *fp;

typedef struct _node {
	struct _node *prev;
	int n;
} node;
node *first, *llast, *c;

void init()
{
	first = malloc(sizeof(node));
	llast = first;
	first->prev = NULL;
}

void destroy()
{
	c = llast;
	while (c) {
		llast = llast->prev;
		free(c);
		c = llast;
	}
}

void push(int n)
{
	c = malloc(sizeof(node));
	c->n = n;
	c->prev = llast;
	llast = c;
}

int pop()
{
	int n;
	if (llast == first) return 0;
	n = llast->n;
	c = llast;
	llast = llast->prev;
	free(c);
	return n;
}

void mash()
{
	int i, j;
	srand(time(0));
	for (i = 1; i < n/3; i++) {
		j = rand()%n + 1;
		a[0].x = a[j].x; a[0].y = a[j].y;
		a[j].x = a[n-j+1].x; a[j].y = a[n-j+1].y;
		a[n-j+1].x = a[0].x; a[n-j+1].y = a[0].y;
	}
}

#define L 0.00001
#define ABS(a) ((a) < 0 ? -(a) : (a))

int cmp(const void *a, const void *b)
{
	float x1, x2, y1, y2, r;
	x1 = ((const point*)a)->x;
	y1 = ((const point*)a)->y;
	x2 = ((const point*)b)->x;
	y2 = ((const point*)b)->y;
	r = - x1*y2 + x2*y1;
	if ((x1 == 0) && (y1 == 0)) return -1;
	if ((x2 == 0) && (y2 == 0)) return 1;
	if (ABS(r) < L) return x1 - x2;
	return r;
}

float turn(float x1, float y1, float x2, float y2)
{
	return x1*y2 - x2*y1;
}
/*
	turn() > 0 => trig
	turn() < 0 => orar
*/

main()
{
	int i;
	init();
	fp = fopen("inter.in", "rt");
	fscanf(fp, "%d", &n);
	n *= 2;
	for (i = 1; i <= n; i++) {
		fscanf(fp, "%f%f", &a[i].x, &a[i].y);
		if (i == 1) {
		 	minx = a[1].x;
			miny = a[1].y;
		}
		else if (a[i].y < miny) {
			minx = a[i].x;
			miny = a[i].y;
		}
		else if ((a[i].y == miny) && (a[i].x < minx)) {
			minx = a[i].x;
		}
	}
	fclose(fp);
	
	for (i = 1; i <= n; i++) {
		a[i].x -= minx;
		a[i].y -= miny;
	}
	mash();
	qsort(&a[1], n, sizeof(point), cmp);

	push(1);
	last = 0;
	curr = 1;
	for (i = 2; i <= n; i++) {
		if ((ABS(a[i].x - a[curr].x) < L) &&
			(ABS(a[i].y - a[curr].y) < L)) continue;
		else if (last == 0) {
			last = curr;
			curr = i;
			push(i);
			continue;
		}

		if (turn(a[i].x - a[curr].x, //trig => in inf conv
				 a[i].y - a[curr].y,
				 a[last].x - a[curr].x,
				 a[last].y - a[curr].y) > -L) {
			last = curr;
			curr = i;
			push(i);
		}
		else {
			do {
				curr = last;
				last = pop();
			} while (turn(a[i].x - a[curr].x,
			a[i].y - a[curr].y,
			a[last].x - a[curr].x,
			a[last].y - a[curr].y) <= -L);
		}
	}

	minx = 0;
	miny = 0;
	S = 0;

	for (i = pop(); i; i = pop()) {
		S += (a[i].y + miny)/2 * (a[i].x - minx);
		minx = a[i].x;
		miny = a[i].y;
	}

	fp = fopen("inter.out", "wt");
	fprintf(fp, "%.2f\n", S);
	fclose(fp);
	return 0;
}
