program inter;
const
  sin='inter.in';
  sout='inter.out';
  maxn=5*1000;
type
  tcoord=
    record
      x,y:real;
    end;
  tcoords=array[0..maxn]of tcoord;
  tcoords2=array[0..1] of ^tcoords;
  pcoords=^tcoords2;
  tl=array[1..maxn*2]of real;
var
  fin,fout:text;
  points:tcoords2;
  ipoints:tcoords2; {Intersection Points}
  extremities:tcoords2;
  n:longint;
  angle:tl;
  sol:real;
  newn:longint;

procedure alloc(var c:tcoords2);
var
  i:longint;
begin
  for i:=0 to 1 do
    begin
      new(c[i]);
      fillchar(c[i]^,sizeof(c[i]^),0);
    end;
end;

procedure assign_p(p:pcoords;i:longint;x,y:real);
var
  seg,ofs:longint;
begin
  dec(i);
  seg:=i div maxn;
  ofs:=i mod maxn;
  p^[seg]^[ofs].x:=x;
  p^[seg]^[ofs].y:=y;
end;

procedure Get_P(p:pcoords;i:longint;var x,y:real);
var
  seg,ofs:longint;
begin
  if newn<>0 then
    if i<1 then {for the area calculation}
      i:=n
    else
      if i>newn then {we need to go around with the poly}
        i:=1;
    dec(i);
  seg:=i div maxn;
  ofs:=i mod maxn;
  x:=p^[seg]^[ofs].x;
  y:=p^[seg]^[ofs].y;
end;

procedure read_data;
var
  i:longint;
  x1,y1,x2,y2:real;
begin
  alloc(points);
  assign(fin,sin);
  reset(fin);
  read(fin,n);
  for i:=1 to n do
    begin
      read(fin,x1,y1,x2,y2);
      assign_p(@points,i*2-1,x1,y1);
      assign_p(@points,i*2,x2,y2);
    end;
  close(fin);
end;

procedure clear_p(p:pcoords);
var
  i:longint;
begin
  for i:=0 to 1 do
    fillchar(p^[i]^,sizeof(p^[i]^),0);
end;

function coef(x1,y1,x2,y2:real; var a,b,c:real):integer; {0:ok}
                                                         {1:horiz}
                                                         {2:vert}
begin
  a:=y1-y2;
  b:=x2-x1;
  c:=-a*x1-b*y1;
end;

procedure GetIntersection(x1,y1,x2,y2,x3,y3,x4,y4:real;var ix,iy:real);
var
  a1,b1,c1:real; {first line}
  a2,b2,c2:real; {second line}
  delta,deltax,deltay:real;
begin
  coef(x1,y1,x2,y2,a1,b1,c1);
  coef(x3,y3,x4,y4,a2,b2,c2);
  c1:=-c1;
  c2:=-c2;
  delta:=a1*b2-b1*a2;
  deltax:=c1*b2-b1*c2;
  deltay:=a1*c2-c1*a2;
  if delta=0 then
    delta:=0;
  ix:=deltax/delta;
  iy:=deltay/delta;
end;

procedure CompInter(i:longint);
var
  x1,y1,x2,y2:real; {first line}
  x3,y3,x4,y4:real; {second line}
  ix,iy:real; {intersection point for x and y}
  j,ns:longint;
begin
  clear_p(@ipoints);
  Get_P(@points,i*2-1,x1,y1);
  Get_P(@points,i*2,x2,y2);
  ns:=0;
  for j:=1 to n do
    if i<>j then
      begin
        inc(ns);
        Get_P(@points,j*2-1,x3,y3);
        Get_P(@points,j*2,x4,y4);
{        if (x3=0)and(y3=0)and}
        GetIntersection(x1,y1,x2,y2,x3,y3,x4,y4,ix,iy);
        assign_p(@ipoints,ns,ix,iy);
      end;
end;

function dist(x1,y1,x2,y2:real):real;
begin
  dist:=sqrt(sqr(x1-x2)+sqr(y1-y2));
end;

function sgn_p(x1,y1,x2,y2:real):real;
begin
  if (x1>x2) or ((x1=x2)and(y1>y2)) then
    sgn_p:=+1
  else
    sgn_p:=-1;
end;

function SignedDist(x1,y1,x2,y2:real):real;
var
  ret:real;
begin
  ret:=dist(x1,y1,x2,y2);
  ret:=ret*sgn_p(x1,y1,x2,y2);
  SignedDist:=ret;
end;

procedure GetTwoExtremities(var x1,y1,x2,y2:real);
var
  x,y:real; {pivot}
  xx,yy:real; {punct contor}
  minx,miny,maxx,maxy:real;
  i:longint;
  mindist,maxdist:real;
  minpoz,maxpoz:longint;
  dist:real;
begin
  Get_P(@ipoints,1,x,y);
  mindist:=0;maxdist:=0;
  minpoz:=1;maxpoz:=1;
  maxx:=x;
  maxy:=y;
  minx:=x;
  miny:=y;
  for i:=2 to n-1 do
    begin
      Get_P(@ipoints,i,xx,yy);
      dist:=SignedDist(x,y,xx,yy);
      if dist>maxdist then
        begin
          maxdist:=dist;
          maxpoz:=i;
          maxx:=xx;
          maxy:=yy;
        end;
      if dist<mindist then
        begin
          mindist:=dist;
          minpoz:=i;
          minx:=xx;
          miny:=yy;
        end;
    end;
  x1:=minx;
  y1:=miny;
  x2:=maxx;
  y2:=maxy;
end;

function GetAngle(x,y:real):real;
var
  delta:real;
  unghi:real;
begin
  if x=0 then
    begin
      if y>0 then
        GetAngle:=90
      else
        GetAngle:=270;
      exit;
    end;
  if y=0 then
    begin
      if x>=0 then
        GetAngle:=0
      else
        GetAngle:=180;
      exit;
    end;
  delta:=abs(y/x);
  unghi:=arctan(delta)*180/pi;
  if (y>0) then
    if (x>0) then
      GetAngle:=unghi
    else
      GetAngle:=180-unghi
  else
    if (x>0) then
      GetAngle:=360-unghi
    else
      GetAngle:=180+unghi;
end;

procedure CalcCentru(var x,y:real);
var
  sumx,sumy:real;
  i:longint;
  xx,yy:real;
begin
  sumx:=0;
  sumy:=0;
  for i:=1 to 2*n do
    begin
      Get_P(@extremities,i,x,y);
      sumx:=sumx+x;
      sumy:=sumy+y;
    end;
  x:=sumx/(2*n);
  y:=sumy/(2*n);
end;

procedure comp_data;
var
  i:longint;
  x1,y1,x2,y2:real;
  x,y:real;
  ox,oy:real; {centrul de greutate}
  xx,yy:real;
begin
  alloc(ipoints);
  alloc(extremities);
  for i:=1 to n do
    begin
      CompInter(i); {it generates the (N-1) intersection points}
      GetTwoExtremities(x1,y1,x2,y2);
      assign_p(@extremities,i*2-1,x1,y1);
      assign_p(@extremities,i*2,x2,y2);
    end;
  CalcCentru(ox,oy);
  for i:=1 to 2*n do
    begin
      Get_P(@extremities,i,x,y);
      xx:=x-ox;
      yy:=y-oy;
      angle[i]:=GetAngle(xx,yy);
    end;
end;

procedure swap_r(var a,b:real);
var
  c:real;
begin
  c:=a;
  a:=b;
  b:=c;
end;

procedure swap_p(p:pcoords;a,b:longint);
var
  seg1,ofs1:longint;
  seg2,ofs2:longint;
  aux:tcoord;
begin
  dec(a);
  seg1:=a div maxn;
  ofs1:=a mod maxn;
  dec(b);
  seg2:=b div maxn;
  ofs2:=b mod maxn;
  aux:=p^[seg1]^[ofs1];
  p^[seg1]^[ofs1]:=p^[seg2]^[ofs2];
  p^[seg2]^[ofs2]:=aux;
end;

procedure quicksort(start,stop:longint);
var
  sta,sto:longint;
  mid:real;
begin
  if start>=stop then
    exit;
  sta:=start;
  sto:=stop;
  mid:=angle[(start+stop)div 2];
  repeat
     while mid>angle[sta] do inc(sta);
     while angle[sto]>mid do dec(sto);
     if sta<=sto then
       begin
         swap_r(angle[sta],angle[sto]);
         swap_p(@extremities,sta,sto);
         inc(sta);
         dec(sto);
       end;
  until sta>sto;
  quicksort(start,sto);
  quicksort(sta,stop);
end;

procedure Sort_Data;
begin
  quicksort(1,2*n);
end;

function Different(x1,y1,x2,y2:real):boolean;
begin
  Different:=(x1<>x2)or(y1<>y2);
end;

procedure eliminate;
var
  i:longint;
  ns:longint;
  xx,yy:real;
  x,y:real;
begin
  ns:=1;
  for i:=2 to 2*n do
    begin
      Get_P(@extremities,i,xx,yy);
      Get_P(@extremities,ns,x,y);
      if Different(xx,yy,x,y) then
        begin
          inc(ns);
          assign_p(@extremities,ns,xx,yy);
        end;
    end;
  n:=ns;
end;

procedure calc_solu;
var
  i:longint;
  xi,yi:real;
  xim,yim:real; {minus}
  xip,yip:real; {plus}
begin
  newn:=n;
  sol:=0;
  for i:=1 to n do
    begin
      Get_P(@extremities,i,xi,yi);
      Get_P(@extremities,i-1,xim,yim);
      Get_P(@extremities,i+1,xip,yip);
      sol:=sol+yi*(xim-xip);
    end;
  sol:=abs(sol)/2;
end;

procedure write_sol;
var
  s:string;
begin
  assign(fout,sout);
  rewrite(fout);
  sol:=sol*100;
  Str(sol:0:0,s);
  writeln(fout,copy(s,1,length(s)-2),'.',copy(s,length(s)-1,2));
  close(fout);
end;

begin
  newn:=0;
  read_data;
  comp_data;
  sort_data;
  eliminate;
  calc_solu;
  write_sol;
  halt(0);
end.
