#pragma option -3 -O2 -G -Z -ff -f287
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#ifdef __BORLANDC__
#else
#define far
#endif

float far a[5000], far b[5000], far c[5000];
float far px1[5000], px2[5000], far py1[5000], far py2[5000];
int ndx[10000], far st[10000];

#define ptx(p)		(((p) & 0x4000) ? px2[(p) & 0x3fff] : px1[p])
#define pty(p)		(((p) & 0x4000) ? py2[(p) & 0x3fff] : py1[p])

int crossprod(int pa, int po, int pb) {
	float x1, x2, x0, y1, y2, y0;
	float d;

	x1 = ptx(pa); x2 = ptx(pb); x0 = ptx(po);
	y1 = pty(pa); y2 = pty(pb); y0 = pty(po);
	d = ((x1 - x0) * (y2 - y0)) - ((x2 - x0) * (y1 - y0));
	return (d > 0) ? 1 : ((d < 0) ? -1 : 0);
}
int icmp(void const *a, void const *b) {
	int pa, pb;
	float d;

	pa = *(int *)a; pb = *(int *)b;
	d = ptx(pa) * pty(pb) - ptx(pb) * pty(pa);
	return (d > 0) ? 1 : ((d < 0) ? -1 : 0);
}

int main() {
	FILE *fp;
	double la, lb, lc, ma, mb, mc;
	double p_x1, p_x2, p_y1, p_y2;
	double d, xc, yc;
	int pc;
	int n, x, y;
	int ss;

	// load
	fp = fopen("inter.in", "rt");
	fscanf(fp, "%d", &n);
	for(x = 0; x < n; x++) {
		fscanf(fp, "%lf%lf%lf%lf", &p_x1, &p_y1, &p_x2, &p_y2);
		a[x] = p_y1 - p_y2;
		b[x] = p_x2 - p_x1;
		c[x] = -a[x] * p_x1 - b[x] * p_y1;
	}
	fclose(fp);

	// inter count
	for(x = 0; x < n; x++) {
		px1[x] = -1e10; py1[x] = -1e10;
		px2[x] = 1e10; py2[x] = 1e10;
	}

	for(x = 0; x < n; x++) {
		la = a[x]; lb = b[x]; lc = c[x];
		for(y = x + 1; y < n; y++) {
			ma = a[y]; mb = b[y]; mc = c[y];
#define a1		la
#define b1		lb
#define c1		lc
#define a2		ma
#define b2		mb
#define c2		mc
			d = a1 * b2 - a2 * b1;
			if(fabs(d) < 1e-8) continue;
			xc = (b1 * c2 - b2 * c1) / d;
			yc = (a2 * c1 - a1 * c2) / d;
#undef c2
#undef b2
#undef a2
#undef c1
#undef b1
#undef a1

			if(xc > px1[x] || xc == px1[x] && yc > py1[x]) { px1[x] = xc; py1[x] = yc; }
			if(xc > px1[y] || xc == px1[y] && yc > py1[y]) { px1[y] = xc; py1[y] = yc; }
			if(xc < px2[x] || xc == px2[x] && yc < py2[x]) { px2[x] = xc; py2[x] = yc; }
			if(xc < px2[y] || xc == px2[y] && yc < py2[y]) { px2[y] = xc; py2[y] = yc; }
		}
	}

	// prep 4 hull: index and minp/maxp
	xc = 1e10; yc = 1e10;
	for(x = 0; x < n; x++) {
		ndx[x * 2] = x;
		ndx[x * 2 + 1] = x | 0x4000;
		if(px1[x] < xc) { xc = px1[x]; yc = py1[x]; pc = x * 2; }
		else if(px1[x] == xc && py1[x] < yc) { yc = py1[x]; pc = x * 2; }
		if(px2[x] < xc) { xc = px2[x]; yc = py2[x]; pc = x * 2 + 1; }
		else if(px2[x] == xc && py2[x] < yc) { yc = py2[x]; pc = x * 2 + 1; }
	}
	// origin-align
	ss = ndx[pc];
	ndx[pc] = ndx[n * 2 - 1];
	ndx[n * 2 - 1] = ss;
	for(x = 0; x < n; x++) {
		px1[x] -= xc; py1[x] -= yc;
		px2[x] -= xc; py2[x] -= yc;
	}
	qsort(ndx, n * 2 - 1, sizeof(ndx[0]), icmp);
	// ch
	st[0] = ndx[n * 2 - 1];
	st[1] = ndx[0]; ss = 2;
	for(x = 1; x < n * 2 - 1; x++) {
		pc = ndx[x];
		while(ss >= 2 && crossprod(pc, st[ss - 1], st[ss - 2]) <= 0)
			ss--;
		st[ss++] = pc;
	}

	fp = fopen("inter.out", "wt");
	// area
	st[ss] = st[0];
	la = 0.0;
	for(x = 0; x < n; x++) {
		la += ptx(st[x]) * pty(st[x + 1]) - ptx(st[x + 1]) * pty(st[x]);
	}
	la = 0.5 * fabs(la);
	fprintf(fp, "%lf\n", la);
	fclose(fp);

	return 0;
}