/* Complexity: O(N) */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void die() {
	FILE *fp;

	fp = fopen("nr.out", "wt");
	fprintf(fp, "0\n");
	fclose(fp);
	exit(0);
}

char inr[1024];
char mynr[1024];
int dcount[16];
int n;

int domin(int p) {
	int c;

	// final stroke
	if(p * 2 + 1 >= n) {
		if(memcmp(mynr, inr, n) > 0)
			return 1;
		return 0;
	}

	// digit alloc - first found >= current
	for(c = 0; c < 9; c++) {
		if(dcount[c]) {
			mynr[p] = c + '0'; mynr[n - p - 1] = c + '0';
			dcount[c] -= 2;
			if(domin(p + 1))
				return 1;
			dcount[c] += 2;
		}
	}
	return 0;
}
int domg(int p) {
	int c;

	// final stroke
	if(p * 2 + 1 >= n) {
		if(memcmp(mynr, inr, n) > 0)
			return 1;
		return 0;
	}

	// digit alloc - first found >= current
	for(c = inr[p] - '0'; c < 9; c++) {
		if(dcount[c]) {
			mynr[p] = c + '0'; mynr[n - p - 1] = c + '0';
			dcount[c] -= 2;
			if(c == inr[p] - '0') {
				if(domg(p + 1))
					return 1;
			}
			else {
				if(domin(p + 1))
					return 1;
			}
			dcount[c] += 2;
		}
	}
	return 0;
}

int main() {
	FILE *fp;
	int x;

	fp = fopen("nr.in", "rt");
	fscanf(fp, "%d", &n);
	fscanf(fp, "%s", inr);
	fclose(fp);

	for(x = 0; x < n; x++)
		dcount[inr[x] - '0']++;

	if(n & 1) {
		// find middle digit
		for(x = 0; x < 10; x++) {
			if(dcount[x] & 1) break;
		}
		if(x < 10) {
			mynr[n / 2]  = x + '0';
			dcount[x]--;
		}
		else
			die();
	}
	// full digit check
	for(x = 0; x < 10; x++)
		if(dcount[x] & 1) die();

	if(!domg(0))
		die();

	fp = fopen("nr.out", "wt");
  fprintf(fp, "%s\n", mynr);
	fclose(fp);

	return 0;
}