/* Complexity: O(lg N * sqrt N) -- now
O(P * lg N) -- commented out */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define min(a, b)			((a) < (b) ? (a) : (b))
// nt, but faster
#define do_plan			do_plan_1

//#define do_plan			do_plan_2

unsigned long k1, k2;
unsigned long p, s;
#define substract(np, nt)			{ \
	t2 = np * (nt / 2); \
	s2 = min(t2, lk2); lk2 -= s2; \
	t1 = np * nt - 2 * s2; \
	s1 = min(t1, lk1); lk1 -= s1; \
}

int do_plan_1(unsigned long t) {
	unsigned long x, nx, tx;
	unsigned long t1, t2, s1, s2;
	unsigned long lk1, lk2;
	unsigned long sk;


	lk1 = k1; lk2 = k2;
	// compute for first processors
	for(x = 1; x <= s; x++) {
		tx = t / x;
		substract(1, tx);
	}
	x--;

	// bulk compute for next processors
	for(tx--; tx >= 1 && nx < p; tx--) {
		nx = t / tx;
		if(p < nx) nx = p;
		substract((nx - x), tx);
		x = nx;
	}

	return !lk1 && !lk2;
}

int do_plan_2(unsigned long t) {
	unsigned long t1, t2, s1, s2;
	unsigned long lk1, lk2;
	unsigned long x, tx;

	lk1 = k1; lk2 = k2;
	// compute for all processors
	for(x = 1; x <= p; x++) {
		tx = t / x;
		substract(1, tx);
	}

	return !lk1 && !lk2;
}

int main() {
	FILE *fp;
	long n, k;
	unsigned long l, r, x;
	long t;
	long a;

	// load
	fp = fopen("proc.in", "rt");
	fscanf(fp, "%ld%ld%ld", &n, &k, &p);
	fclose(fp);

	// precalculate sqrt(t)
	k1 = k; k2 = n - k;
	t = 2 * k2 + k1;
	for(s = 1; s * s < t; s++);
	if(p < s) s = p;

	// binary search for exec time
	l = 1; r = 2 * k2 + k1;
	while(l <= r) {
		x = (l + r) >> 1;
		if(do_plan(x)) {
			a = x;
			r = x - 1;
		}
		else
			l = x + 1;
	}


	// score
	fp = fopen("proc.out", "wt");
	fprintf(fp, "%lu\n", a);
	fclose(fp);

	return 0;
}