#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N 5010
#define eps 1e-10

struct dreapta {
   double a, b, c;
};
typedef struct dreapta dreapta;

struct point {
   double x, y;
};
typedef struct point point;

#define p(a) ((point *)a)

int n, np;
dreapta d[N];
point p[2*N];
int st[2*N];
char m[2*N];
double area;

void coef (double x1, double y1, double x2, double y2, double *a, double *b, double *c)
{
   *a = y2 - y1;
   *b = x1 - x2;
   *c = y1*x2 - x1*y2;
}

void read ()
{
   int i;
   double x1, y1, x2, y2;
   
   FILE *f = fopen( "inter.in", "rt" );
   fscanf( f, "%d", &n );
   for ( i = 1; i <= n; i++ )
   {
      fscanf( f, "%lf%lf%lf%lf", &x1, &y1, &x2, &y2 );
      coef( x1, y1, x2, y2, &d[i].a, &d[i].b, &d[i].c );
   }
   fclose( f );
}

void intersect (dreapta a, dreapta b, double *x, double *y)
{
   *x = (a.c * b.b - b.c * a.b) / (a.b * b.a - b.b * a.a);
   *y = (b.c * a.a - a.c * b.a) / (a.b * b.a - b.b * a.a);
}

void find_points ()
{
   double x1, y1, x2, y2, x, y;
   int i, j;
   

   for ( i = 1; i < n; i++ )
   {
      intersect( d[i], d[i + 1], &x1, &y1 );
      if ( i < n - 1 ) intersect( d[i], d[i + 2], &x2, &y2 );
      for ( j = i + 3; j <= n; j++ )
      {
         intersect( d[i], d[j], &x, &y );
         if ( (x-x1)*(x-x2) >= 0 && (y-y1)*(y-y2) >= 0 )
         {
            if ( (x-x1)*(x-x1)+(y-y1)*(y-y1) < (x-x2)*(x-x2)+(y-y2)*(y-y2) )
               x1 = x, y1 = y;
            else
               x2 = x, y2 = y;
         }
      }
      p[++np].x = x1; p[np].y = y1;
      if ( i < n - 1 )
         p[++np].x = x2, p[np].y = y2;
   }
}

int cmp (const void *a, const void *b)
{
   return p(a)->y < p(b)->y - eps || fabs( p(a)->y - p(b)->y ) < eps && p(a)->x < p(b)->x ? -1 : 1;
}

int concav (point a, point b, point c)
{
   return a.x*(b.y-c.y) - b.x*(a.y-c.y) + c.x*(a.y-b.y) < 0;
}

void convex_hull ()
{
   int pos, i;
   
   qsort( p + 1, np, sizeof( point ), cmp );
   
   m[2] = 1; st[1] = 1; st[2] = 2; pos = 2;
   for ( i = 3; i <= np; i++ )
   {
      while ( i > 1 && concav( p[st[pos-1]], p[st[pos]], p[i] ) )
         m[st[pos]] = 0, pos--;
      st[++pos] = i; m[i] = 1;
   }

   for ( i = np; i >= 1; i-- )
      if ( !m[i] )
      {
         while ( concav( p[st[pos-1]], p[st[pos]], p[i] ) )
            m[st[pos]] = 0, pos--;
         st[++pos] = i; m[i] = 1;
      }

   for ( i = 1; i < pos; i++ )
      area += (p[st[i]].x * p[st[i+1]].y - p[st[i]].y * p[st[i+1]].x);
   area = fabs( area ) * 0.5;
}

void print ()
{
   FILE *fout = fopen( "inter.out", "wt" );
   fprintf( fout, "%.2lf\n", area );
   fclose( fout );
}

int main ()
{
   read();
   find_points();
   convex_hull();
   print();
   return 0;
}
