#include<stdio.h>
#include<math.h>
#define LIM 5007

#define SUPERMARE 1e200
#define SUPERMIC 1e200
#define eps 0.00001
int N;
double A[LIM],B[LIM],C[LIM];
double X[3*LIM],Y[3*LIM];
double X2[3*LIM],Y2[3*LIM];
double CHX[4*LIM];
double CHY[4*LIM];
int CHN,NP;
double ARIE;


void merge(int p,int q,int r)
{
	int i,j,k;
	i=p;j=q+1;k=p;
	while(i<=q && j<=r)
		if( (fabs(Y[i]-Y[j])<=eps) && X[i]<X[j] || Y[i]<Y[j])
		{
			Y2[k]=Y[i];
			X2[k]=X[i];
			k++;i++;
		}
		else
		{
			Y2[k]=Y[j];
			X2[k]=X[j];
			k++;j++;
		}
	while(i<=q)
	{
		Y2[k]=Y[i];
		X2[k]=X[i];
		k++;i++;
	}
	while(j<=r)
	{
		Y2[k]=Y[j];
		X2[k]=X[j];
		k++;j++;
	}
	for(i=p;i<=r;i++)
	{X[i]=X2[i];Y[i]=Y2[i];}
}

void sort(int p,int r)
{
	if(r>p)
	{
		int q;
		q=r+p>>1;
		sort(p,q);
		sort(q+1,r);
		merge(p,q,r);
	}
}

int inters(int d1,int d2,double* x0,double* y0)
{
	double D,D1,D2;
	D=A[d1]*B[d2]-A[d2]*B[d1];
	D1=C[d1]*B[d2]-C[d2]*B[d1];
	D2=A[d1]*C[d2]-A[d2]*C[d1];
	if(fabs(D)<=eps) return 0;
	*x0=-D1/D;
	*y0=-D2/D;
	return 1;
}

double pvect(int index)
{
	return (CHX[CHN]-CHX[CHN-1])*(Y[index]-CHY[CHN])-
		(CHY[CHN]-CHY[CHN-1])*(X[index]-CHX[CHN]);
}

int  main()
{
	int i,j,flix;
	FILE* f;
	f=fopen("inter.in","r");
	fscanf(f,"%d",&N);	
	for(i=1;i<=N;i++)
	{
		double x1,x2,y1,y2;
		fscanf(f,"%lf%lf%lf%lf",&x1,&y1,&x2,&y2);
		A[i]=y1-y2;
		B[i]=x2-x1;
		C[i]=x1*y2-x2*y1;
	}
	fclose(f);
	NP=0;
	for(i=1;i<=N;i++)
	{
		double xmin,ymin,xmax,ymax;
		int modif;
		modif=0;
		for(j=i+1;j<=N;j++)
		{
			double x0,y0;
			if(inters(i,j,&x0,&y0))
				if(modif)
				{
					if(fabs(y0-ymax)<=eps)	
					{
						if(x0<xmin)
						  {xmin=x0;ymin=y0;}
						else if(x0>xmax)
						  {xmax=x0;ymax=y0;}
					}
					else
					{
						if(y0<ymin)
						{ymin=y0;xmin=x0;}
						else if(y0>ymax)
							{ymax=y0;xmax=x0;}
					}
				}
				else
				{
					xmin=xmax=x0;
					ymin=ymax=y0;
					modif=1;
				}

		}
		if(modif)
		{	
			NP++;
			X[NP]=xmin;
			Y[NP]=ymin;
			NP++;
			X[NP]=xmax;
			Y[NP]=ymax;
		}
	}
	// finit const vector
	// infasurare convexa
	sort(1,NP);
	flix=1;
	for(i=2;i<=NP;i++)
		if(!(fabs(X[i]-X[flix])<=eps && fabs(Y[i]-Y[flix])<=eps))
		{
			flix++;
			X[flix]=X[i];
			Y[flix]=Y[i];
		}
	NP=flix;
	if(NP!=1)
	{	
		CHN=2;
		CHX[1]=X[1];
		CHY[1]=Y[1];
		CHX[2]=X[2];
		CHY[2]=Y[2];	
		for(i=3;i<=NP;i++)
		{
			while(CHN>=2 && (pvect(i))<=0)
				CHN--;
			CHN++;
			CHX[CHN]=X[i];
			CHY[CHN]=Y[i];
		}
		for(i=NP-1;i>=1;i--)
		{
			while(CHN>=2 && (pvect(i))<=0)
				CHN--;
			CHN++;
			CHX[CHN]=X[i];
			CHY[CHN]=Y[i];	
		}
		ARIE=0;
		for(i=1;i<CHN;i++)
			ARIE+=0.5*(CHX[i]*CHY[i+1]-CHX[i+1]*CHY[i]);
		ARIE=fabs(ARIE);
	}
	else ARIE=0;
	f=fopen("inter.out","w");
	fprintf(f,"%.2lf",ARIE);
	fclose(f);
	return 0;	
}
