#include <string.h>
#include <stdio.h>
#include <stdlib.h>


#define N_MAX	1000
#define BASE	10

#define IN_NAME	"nr.in"
#define OUT_NAME "nr.out"
#define IS_SOL	1


int A[BASE], n_digits, k;
int number[N_MAX], current[N_MAX];
int st[N_MAX];


void read_data(void)
{
    int i;
    FILE *in_file = fopen(IN_NAME, "rt");

    for (fscanf(in_file, "%d\n", &n_digits), i = 0; i < n_digits; i++) {
	fscanf(in_file, "%1d\n", number + i);
	A[number[i]]++;
    }
    fclose(in_file);
}


void write_solution(int *array, int status)
{
    int i;
    FILE *out_file = fopen(OUT_NAME, "wt");

    if (status == IS_SOL) {
	for (i = 0; i < n_digits; i++)
	    fprintf(out_file, "%d", array[i]);
	fprintf(out_file, "\n");
    } else {
	fprintf(out_file, "0\n");
    }
    exit(EXIT_SUCCESS);
}


void build_number(int *array, int digits)
{
    int i, k;

    for (k = i = 0; i < digits; i++)
	current[k++] = st[i];
    for (i = 0; i < BASE; i++)
	if (A[i]) current[k++] = i;
    for (i = 0; i < digits; i++)
	current[k++] = st[digits - 1 - i];
}


void back(short lv, short status)
{
    int i;

    if (lv == n_digits / 2) {
	if (status) {
	    /* found one that is already greater */
	    build_number(current, lv);
	    write_solution(current, IS_SOL);
	} else {
	    /* build this one and test it */
	    build_number(current, lv);
	    if (memcmp(number, current, n_digits * sizeof(int)) < 0) {
		/* it is greater */
		write_solution(current, IS_SOL);
	    }
	}
    } else {
	for (i = lv ? 0 : 1 /* should be superfluous */; i < BASE; i++)
	    if (A[i] >= 2 && ((!status && i >= number[lv]) || status)) {
		st[lv] = i;
		A[i] -= 2;
		back(lv + 1, status || (i > number[lv]));
		A[i] += 2;
	    }
    }
}


void solve(void)
{
    int i, n_odd = 0;

    for (i = 0; i < BASE; i++) {
	n_odd += A[i] % 2;
    }
    if ((n_digits % 2 && n_odd != 1) || (n_digits % 2 == 0 && n_odd)) {
	write_solution(NULL, !IS_SOL);
    } else {
	back(0, 0);
	write_solution(NULL, !IS_SOL);
    }
}


int main(void)
{
    read_data();
    solve();

    return EXIT_FAILURE; /* not reachable */
}

/* vim: set sw=4 sts=4 */
