#include <stdio.h>
#include <stdlib.h>


#define IN_NAME	"proc.in"
#ifdef __DEBUG__
#   define OUT_NAME "/dev/console"
#else
#   define OUT_NAME "proc.out"
#endif


int optimal_time = -1;
int N, K, P;


void read_data(void)
{
    FILE *in_file = fopen(IN_NAME, "rt");

    fscanf(in_file, "%d %d %d\n", &N, &K, &P);
    fclose(in_file);
}

int try_time(int time)
{
    int i, n_simple, n_double;

    n_simple = K;
    n_double = N - K;
    for (i = P; i >= 1; i--) {
	int _temp, current = time;
#define MIN(i, j) ((i) < (j) ? (i) : (j))

	n_double -= (_temp = MIN(current / (2 * i), n_double));
	current -= _temp * 2 * i;
	n_simple -= MIN(current / (1 * i), n_simple);
    }
    return !(n_simple || n_double);
}


void solve(void)
{
    int i, step;

    /* do a bsearch ... */
    for (i = 0, step = (1 << 30);; step >>= 1) {
	if (try_time(i + step))
	    optimal_time = i + step;
	else
	    i += step;
	if (step == 0) break;
    }
}


void write_output(void)
{
    FILE *out_file = fopen(OUT_NAME, "wt");

    fprintf(out_file, "%d\n", optimal_time);
    fclose(out_file);
}


int main(void)
{
    read_data();
    solve();
    write_output();

    return EXIT_SUCCESS;
}

/* vim: set sw=4 sts=4: */
