#include <stdio.h>
#include <memory.h>


struct m_point {
   float x, y;
   m_point *next;
};
m_point *root, *total, *cur, *me, tempP;
int k = 0;

// --------------------------------------------
inline float fabsf(float me)
{
   if (me < 0.0f) return -me;
   else           return  me;
}

inline long double fabsL(long double me)
{
   if (me < 0.0L) return -me;
   else           return  me;
}

// --------------------------------------------
inline int checkOut(float x, float y, m_point *me)
{
    float dx, dy, a, b, temp;

    dx = me->next->x - me->x;
    dy = me->next->y - me->y;

    if (dx == 0.0f && dy == 0.0f) return 0;

    temp = 1.0f / (dx*dx + dy*dy);
    a = ((x - me->x) * dx + (y - me->y) * dy) * temp;
    if (a <= 0.0f) return 0;


/*
    if (fabsf(dy) > fabsf(dx)) b = ( x - me->x - a * dx) / dy;
    else                       b = (-y + me->y + a * dy) / dx;
    if (b > 0.0f) return 0;
    if (a < 0.0f) return -1;

    b = (-dy * (x - me->x) + dx * (y - me->y)) * temp;
    if (b > 0.0f) return 0;
*/
    return 1;
}

// --------------------------------------------
void insert(float x, float y)
{
   int j;
   cur = root;

   do {

      j = checkOut(x, y, cur);
      if (j == 1)
      {
	 me = &total[k++];
	 me ->next = cur->next;
	 cur->next = me;

	 me->x = x;
	 me->y = y;

	 tempP.x = x;
	 tempP.y = y;
	 tempP.next = me->next->next;
	 // check if complete
	 while (checkOut(me->next->x, me->next->y, &tempP))
	 {
	       me->next = tempP.next;
	       if (tempP.next == root) root = tempP.next->next;

	       tempP.next = tempP.next->next;
	 }
	 break;
      }
//      if (j == -1) break;

      cur = cur->next;
   } while (cur != root);
}


// --------------------------------------------
inline long double calcAria(m_point *a, m_point *b, m_point *c)
{
   return 0.5L*fabsL(a->x * b->y + b->x * c->y + c->x * a->y -
		     a->x * c->y - b->x * a->y - c->x * b->y);
}

// --------------------------------------------
//
//
// --------------------------------------------
int main(void)
{
    int n, i;
    float x1, x2, y1, y2;

    long double aria= 0.0;

    FILE *f = fopen("inter.in", "r");
    fscanf(f, "%d\n", &n);

    total = new m_point [(n+1)*2];
    memset(total, 0, sizeof(m_point)*(n+1)*2);

    root  = &total[k++];

    for (i=0; i<n; i++)
    {
	fscanf(f, "%f %f %f %f\n", &x1, &y1, &x2, &y2);

	if (i)
	{
	    insert(x1, y1);
	    insert(x2, y2);
	} else {
	   root->next = &total[k++];
	   root->next->next = root;

	   root->x = x1;
	   root->y = y1;
	   root->next->x = x2;
	   root->next->y = y2;
	}
    }

    fclose(f);

    cur = root->next;
    while (cur != root)
    {
	aria += calcAria(root, cur, cur->next);
	cur   = cur->next;
    }

    f = fopen("inter.out", "w");
    fprintf(f, "%.2Lf\n", aria);
    fclose(f);

    return 0;
}
